<?php
set_time_limit (0);
if (($installer_dir = get_installer_dir ($argc, $argv)) === false) {
	return (false);
}
load_classes ($installer_dir);
printf (
	"\n" .
	"If you have any questions or want to report a bug,\n" .
	"please contact us at info@awcreator.com" .
	"\n"
);
$settings = install_settings::get ($installer_dir);
if (install_main::run ($settings)) {
	printf ("\nSuccess\n\n");
}

function get_installer_dir ($argc, $argv)
{
	if ($argc < 1) {
		printf ("Missing script name\n");
		return (false);
	}
	if (($result = realpath ($_SERVER ["SCRIPT_FILENAME"])) == false) {
		printf ("Bad script name\n");
		return (false);
	}
	$result = dirname ($result) . DIRECTORY_SEPARATOR;
	return ($result);
}

function load_classes ($installer_dir)
{
	require_once ($installer_dir . "class_install_main.inc");
	require_once ($installer_dir . "class_install_settings.inc");
	require_once ($installer_dir . "site/system/framework/include/class_sql_manager.inc");
	require_once ($installer_dir . "site/system/framework/include/class_sql_engine_postgresql.inc");
	require_once ($installer_dir . "site/system/framework/include/lib_misc.inc");
	require_once ($installer_dir . "site/system/framework/include/lib_file.inc");
}
?>
