/*
Requires:
	functions_dom.js
	functions_event.js
*/

function field_help (image_id, help_id)
{
	this.dom_image = document.getElementById (image_id);
	this.visible = false;
	this._int_create_window (help_id);
	this._int_attach_events ();
}

field_help.prototype = {
	_int_create_window: function (help_id) {
		var dom_div;

		dom_div = document.createElement ('div');
		dom_div.className = 'help_popup';
		dom_div.style.position = 'absolute';
		dom_div.style.zIndex = '2';
		dom_div.innerHTML = this.messages [help_id];
		this.dom_div = dom_div;
	},

	_int_attach_events: function () {
		var this_obj;

		this_obj = this;
		event_handler_add (this.dom_image, 'mouseover', function (event) {this_obj._int_show ();});
		event_handler_add (this.dom_image, 'mouseout', function (event) {this_obj._int_hide ();});
	},

	_int_show: function () {
		var position;

		if (this.visible) {
			return;
		}
		position = dom_get_position (this.dom_image);
		this.dom_div.style.left = (position.x + 20) + 'px';
		this.dom_div.style.top = position.y + 'px';
		document.body.appendChild (this.dom_div);
		this.visible = true;
	},

	_int_hide: function () {
		if (this.visible == false) {
			return;
		}
		document.body.removeChild (this.dom_div);
		this.visible = false;
	},

	messages: {
		admin_settings_dir_temp:
			'This is the local path to the temporary files directory.<br>' +
			'It must be located on the same filesystem as the<br>' +
			'project run directories of the users.',
		admin_settings_layout_dir_htdocs:
			'This field contains the pathname of the website document<br>' +
			'root. The pathname is relative to the website run directory.<br>' +
			'The value must be a relative pathname which cannot point<br>' +
			'outside of the run directory. If you leave this field empty<br>' +
			'then the document root is assumed to be the same directory<br>' +
			'as the website run directory.',
		admin_settings_layout_dir_system:
			'This field contains the pathname of the website system<br>' +
			'directory. The system directory contains directories and<br>' +
			'files that are used by the server-side code, but should<br>' +
			'not be directly accessible from the client web browser.<br>' +
			'The pathname in this field is relative to the website<br>' +
			'run directory, so it must be a relative pathname which<br>' +
			'cannot point outside of the run directory. If you leave<br>' +
			'this field empty then the system directory is assumed to<br>' +
			'be the same directory as the website run directory.',
		admin_settings_layout_protect_system:
			'Check this box if you want to deny web clients access<br>' +
			'to the system directory. You need this protection only<br>' +
			'when the system directory is located inside the website<br>' +
			'document root. If the system directory is located outside<br>' +
			'of the document root, it is not accessible from the web,<br>' +
			'and there is no need to explicitly protect it. Protection<br>' +
			'of system directory is achieved by using a .htaccess file,<br>' +
			'so your website must allow usage of  .htaccess files in<br>' +
			'order for this protection mechanism to work correctly.',
		admin_settings_layout_profile:
			'This box allows you to quickly select values for the other<br>' +
			'file layout fields. Following profiles are supported:<br>' +
			'<br>' +
			'<span class="help_high">Generic</span>: A generic layout that places the system<br>' +
			'directory inside the website document root. This layout<br>' +
			'will work on any server, but it has a couple of<br>' +
			'drawbacks:<br>' +
			'- You have to watch out when naming directory URLs<br>' +
			'so that they do not clash with the system directory.<br>' +
			'- If your webserver does not support .htaccess files,<br>' +
			'then contents of the system directory will be accessible<br>' +
			'from the client browser.<br>' +
			'<span class="help_high">AWC</span>: An AWC-specific layout, that places the system<br>' +
			'files in a directory outside of the website document root.<br>' +
			'<span class="help_high">Plesk</span>: A layout designed for websites using the Plesk<br>' +
			'control panel. The system files are placed in a Plesk<br>' +
			'specific directory called private/.',
		admin_settings_mysql_admin_password:
			'This field contains the password of the admin user. If you<br>' +
			'leave it empty then the default MySQL password will be<br>' +
			'used when performing administrative actions.',
		admin_settings_mysql_admin_username:
			'This is the username of a MySQL user that can create and<br>' +
			'delete users and databases. Usually you will put here the<br>' +
			'system user <span class="help_high">root</span>. If you leave this field empty, then the<br>' +
			'default MySQL username will be used when performing<br>' +
			'administrative actions.',
		admin_settings_mysql_client_host:
			'This is the IP address (you may use a hostname too) from<br>' +
			'which is accessed the MySQL database during a project run.<br>' +
			'Access to the MySQL client username is allowed from this<br>' +
			'IP address (or hostname), so you must put in this field the<br>' +
			'outgoing IP address (or hostname) of your web server. If<br>' +
			'you put in this field the value <span class="help_high">localhost</span> then a connection<br>' +
			'via a UNIX domain socket will be allowed.',
		admin_settings_mysql_host:
			'Put in this field the server hostname or IP address, e.g.<br>' +
			'<span class="help_high">db.your-server-name.com</span> or <span class="help_high">192.168.1.25</span>.',
		admin_settings_mysql_mechanism:
			'Choose the mechanism used to connect to the MySQL server.',
		admin_settings_mysql_socket_file:
			'The pathname of the MySQL UNIX-domain socket. If you<br>' +
			'leave this field empty, then a default value will be used<br>' +
			'(usually <span class="help_high">/tmp/mysql.sock</span>).',
		admin_settings_mysql_port:
			'Put in this field the server port, e.g. <span class="help_high">1234</span>. If you leave<br>' +
			'this field empty then the default value (usually <span class="help_high">3306</span>)<br>' +
			'will be used when connecting to the database server.',
		admin_settings_mysql_use:
			'Check this box if you want to allow the usage of a MySQL<br>' +
			'database server when running a website. Note that if you<br>' +
			'leave this box unchecked, you will still be able to build<br>' +
			'projects using the MySQL database engine, although you<br>' +
			'will not be able to run them from Advanced Website<br>' +
			'Creator.',
		admin_settings_pathname_ioncube:
			'The pathname of the IonCube encoder binary on the server filesystem.<br>' +
			'Its location depends on the directory you have chosen during the<br>' +
			'installation of the encoder. Please note that you must enter the<br>' +
			'location of the IonCube encoder for PHP5, not for PHP4. Usually the<br>' +
			'name of the encoder binary is <span class="help_high">ioncube_encoder5</span>.<br>' +
			'<br>' +
			'When this field is non-empty, the users can perform an optional<br>' +
			'post-build encoding of projects. You should leave this field<br>' +
			'empty if you do not have IonCube Encoder or want to disallow the<br>' +
			'post-build encoding of projects with IonCube Encoder.',
		admin_settings_pathname_zend:
			'The pathname of the Zend encoder binary on the server filesystem.<br>' +
			'Its location depends on the directory you have chosen during the<br>' +
			'installation of the encoder. Please note that you must enter the<br>' +
			'location of the Zend encoder for PHP5, not for PHP4. Usually the<br>' +
			'name of the encoder binary is <span class="help_high">zendenc5</span>.<br>' +
			'<br>' +
			'When this field is non-empty, the users can perform an optional<br>' +
			'post-build encoding of projects. You should leave this field<br>' +
			'empty if you do not have Zend Encoder or want to disallow the<br>' +
			'post-build encoding of projects with Zend Encoder.',
		admin_settings_postgresql_admin_password:
			'This field contains the password of the admin user. If you leave it<br>' +
			'empty then the default PostgreSQL password will be used when<br>' +
			'performing administrative actions.',
		admin_settings_postgresql_admin_username:
			'This is the username of a PostgreSQL user that can create and<br>' +
			'delete users and databases. Usually you will put here the system<br>' +
			'user <span class="help_high">postgres</span>. If you leave this field empty, then the default<br>' +
			'PostgreSQL username will be used when performing<br>' +
			'administrative actions.',
		admin_settings_postgresql_host:
			'Put in this field the server hostname or IP address, e.g.<br>' +
			'<span class="help_high">db.your-server-name.com</span> or <span class="help_high">192.168.1.25</span>.',
		admin_settings_postgresql_mechanism:
			'Choose the mechanism used to connect to the PostgreSQL server.',
		admin_settings_postgresql_port:
			'Put in this field the server port, e.g. <span class="help_high">1234</span>. If you leave<br>' +
			'this field empty then the default value (usually <span class="help_high">5432</span>)<br>' +
			'will be used when connecting to the database server.',
		admin_settings_postgresql_socket_directory:
			'The directory where the PostgreSQL UNIX-domain socket is<br>' +
			'located. If you leave this field empty, then a default value<br>' +
			'will be used (usually <span class="help_high">/tmp/</span>).',
		admin_settings_postgresql_socket_extension:
			'The extension of the PostgreSQL UNIX-domain socket file.<br>' +
			'If you leave this field empty, then a default value will be<br>' +
			'used (usually <span class="help_high">.5432</span>).',
		admin_settings_postgresql_use:
			'Check this box if you want to allow the usage of a PostgreSQL<br>' +
			'database server when running a website. Note that if you<br>' +
			'leave this box unchecked, you will still be able to build<br>' +
			'projects using the PostgreSQL database engine, although you<br>' +
			'will not be able to run them from Advanced Website Creator.',
		admin_settings_run_dir:
			'This is the directory where website files are output when the user<br>' +
			'runs the project. This should be the same directory that is accessed<br>' +
			'via the site run url from the web browser. You can use the following<br>' +
			'expansions in the field value:<br>' +
			'<br>' +
			'%% - Expands to the % character.<br>' +
			'%i - Expands to the user ID.<br>' +
			'%n - Expands to the username.',
		admin_settings_run_url:
			'This is the HTTP URL which is used to access the content of the<br>' +
			'site run directory. You can use the following expansions in the<br>' +
			'field value:<br>' +
			'<br>' +
			'%% - Expands to the % character.<br>' +
			'%i - Expands to the user ID.<br>' +
			'%n - Expands to the username.',
		admin_settings_sqlite_use:
			'Check this box if you want to allow the usage of a SQLite<br>' +
			'database server when running a website. Note that if you<br>' +
			'leave this box unchecked, you will still be able to build<br>' +
			'projects using the SQLite database engine, although you<br>' +
			'will not be able to run them from Advanced Website<br>' +
			'Creator.',
		admin_settings_sqlite_pathname:
			'This is the pathname of the SQLite database file.<br>' +
			'It must be at least 1 character long. You can use<br>' +
			'the following expansions in the field value:<br>' +
			'<br>' +
			'%% - Expands to the % character.<br>' +
			'%i - Expands to the user ID.<br>' +
			'%n - Expands to the username.',
		admin_user_password:
			'The password must be at least 1 character long.',
		admin_user_username:
			'The username must be at least 1 character long. It can contain<br>' +
			'letters (uppercase or lowercase), digits or underscores and must<br>' +
			'start with a letter (uppercase or lowercase) or an underscore.',
		user_action_cache:
			'When this box is not checked, the runtime framework will send<br>' +
			'several HTTP headers which prevent caching of the returned web<br>' +
			'page by the browser or by any HTTP proxies. Check this box if<br>' +
			'you want to avoid sending these headers.',
		user_action_name:
			'The action name must be at least 1 character long. It can<br>' +
			'contain letters (uppercase or lowercase), digits or underscores<br>' +
			'and must start with a letter (uppercase or lowercase) or an<br>' +
			'underscore.',
		user_action_session:
			'This setting describes the access type which is allowed for the<br>' +
			'<span class="help_high">$session</span> variable which is passed as a parameter to each action<br>' +
			'handler.<br>' +
			'- For access type <span class="help_high">None</span>, the variable null, and any writes that<br>' +
			'change its content will cause a fatal error after the termination<br>' +
			'of the action handler.<br>' +
			'- For access type <span class="help_high">Read</span>, the variable is an array, containing the<br>' +
			'session variables. Reads from it are allowed, but any writes<br>' +
			'that change its content will cause a fatal error after the<br>' +
			'termination of the action handler.<br>' +
			'- For access type <span class="help_high">Read/Write</span>, the variable is an array, containing<br>' +
			'the session variables. Both reads and writes are allowed.<br>' +
			'Keep in mind that for Read and Read/Write access types there<br>' +
			'are respectively read and write locks placed on the session object.<br>' +
			'This means that in order to improve the performance you should<br>' +
			'try to use session access None wherever possible, and prefer<br>' +
			'session access <span class="help_high">Read</span> to session access <span class="help_high">Read/Write</span>.',
		user_constant_name:
			'The constant name must be at least 1 character long. It can contain<br>' +
			'letters (uppercase or lowercase), digits or underscores and must start<br>' +
			'with a letter (uppercase or lowercase) or an underscore.',
		user_constant_value:
			'The constant value is used to initialize the corresponding PHP constant.<br>' +
			'E.g. <span class="help_high">123</span> (an integer constant) or <span class="help_high">"abcdef"</span> (a string constant). Please<br>' +
			'note that for string constants you cannot omit the single or double<br>' +
			'quotes, which enclose the constant value. These quotes are not a part<br>' +
			'of the string, but they are required.',
		user_field_check_int_max:
			'The checked string must represent a valid integer and this integer<br>' +
			'must be equal to or less than this value. The value can range<br>' +
			'from <span class="help_high">-PHP_INT_MAX - 1</span> (which equals to <span class="help_high">-2147483648</span> on 32-bit<br>' +
			'systems) to <span class="help_high">PHP_INT_MAX</span> (which equals to <span class="help_high">2147483647</span> on<br>' +
			'32-bit systems). If you leave this field empty, then no maximum value<br>' +
			'restriction will be imposed.',
		user_field_check_int_min:
			'The checked string must represent a valid integer and this integer<br>' +
			'must be equal to or greater than this value. The value can range<br>' +
			'from <span class="help_high">-PHP_INT_MAX - 1</span> (which equals to <span class="help_high">-2147483648</span> on 32-bit<br>' +
			'systems) to <span class="help_high">PHP_INT_MAX</span> (which equals to <span class="help_high">2147483647</span> on<br>' +
			'32-bit systems). If you leave this field empty, then no minimum value<br>' +
			'restriction will be imposed.',
		user_field_check_length_max:
			'The length of the checked string must be equal to or less than this<br>' +
			'value. The value can range from <span class="help_high">-PHP_INT_MAX - 1</span> (which equals to<br>' +
			'<span class="help_high">-2147483648</span> on 32-bit systems) to <span class="help_high">PHP_INT_MAX</span> (which equals to<br>' +
			'<span class="help_high">2147483647</span> on 32-bit systems). If you leave this field empty, then no<br>' +
			'maximum length restriction will be imposed.',
		user_field_check_length_min:
			'The length of the checked string must be equal to or greater than this<br>' +
			'value. The value can range from <span class="help_high">-PHP_INT_MAX - 1</span> (which equals to<br>' +
			'<span class="help_high">-2147483648</span> on 32-bit systems) to <span class="help_high">PHP_INT_MAX</span> (which equals to<br>' +
			'<span class="help_high">2147483647</span> on 32-bit systems). If you leave this field empty, then no<br>' +
			'minimum length restriction will be imposed.',
		user_field_check_message:
			'You can put here an error message that will be set for the<br>' +
			'corresponding field if this check fails. The message must be<br>' +
			'at least 1 character long and can contain any characters. If<br>' +
			'you leave this value empty, then a default error message<br>' +
			'will be used if the check fails.',
		user_field_check_pcre:
			'The checked string must match the given Perl-Compatible regular<br>' +
			'expression, e.g. <span class="help_high">/^[A-Za-z_][A-Za-z0-9_]{0,63}$/</span>.',
		user_field_check_type:
			'There are several types of build-in field checks:<br>' +
			'<span class="help_high">Integer</span>: Check if the field value is a valid integer and if it<br>' +
			'falls within a specified range. Each of the minimum/maximum<br>' +
			'limits is optional.<br>' +
			'<span class="help_high">Length</span>: Check if the length of the string value falls<br>' +
			'within a specified range. Each of the minimum/maximum limits<br>' +
			'is optional.<br>' +
			'<span class="help_high">List</span>: Check if the field value belongs to the field\'s list.<br>' +
			'This check is supported only for <span class="help_high">Select</span> and <span class="help_high">Multibox</span> fields, since<br>' +
			'they are the only kinds of fields that have lists attached to them.<br>' +
			'<span class="help_high">PCRE</span>: Check if the field value matches a Perl-Compatible<br>' +
			'Regular Expression.<br>' +
			'<span class="help_high">Upload</span>: Check if the field contains a valid uploaded file.',
		user_field_def_list_def_id:
			'Select the list that will be used to populate the <span class="help_high">Select</span> or <span class="help_high">Multibox</span>.<br>' +
			'You can add new lists from the <span class="help_high">Lists</span> menu on the sidebar.',
		user_field_def_list_initial:
			'You can add an initial <span class="help_high">&lt;option&gt;</span> element that will be displayed<br>' +
			'in the current <span class="help_high">&lt;select&gt;</span> element. The definition of the element<br>' +
			'will look like <span class="help_high">&lt;option value="-1"&gt;...&lt;/option&gt;</span>, where <span class="help_high">...</span> is<br>' +
			'the text you will put in this field. If you leave this field<br>' +
			'empty, then the initial <span class="help_high">&lt;option&gt;</span> element will not be added.',
		user_field_def_name:
			'The field definition name must be at least 1 character long. It can<br>' +
			'contain letters (uppercase or lowercase), digits or underscores and<br>' +
			'must start with a letter (uppercase or lowercase) or an underscore.',
		user_field_def_source:
			'Choose the source from which the field value will be fetched.',
		user_field_def_type:
			'Following field types are supported:<br>' +
			'<span class="help_high">Area</span>: Represents a &lt;textarea&gt;...&lt;/textarea&gt; element.<br>' +
			'<span class="help_high">Checkbox</span>: Represents an &lt;input type="checkbox"&gt; element.<br>' +
			'<span class="help_high">File</span>: Represents an &lt;input type="file"&gt; element.<br>' +
			'<span class="help_high">Hidden</span>: Represents an &lt;input type="hidden"&gt; element.<br>' +
			'<span class="help_high">Image</span>: Represents an &lt;input type="image"&gt; element.<br>' +
			'<span class="help_high">Multibox</span>: Represents an array of &lt;input type="checkbox"&gt;<br>' +
			'elements.<br>' +
			'<span class="help_high">Password</span>: Represents an &lt;input type="password"&gt; element.<br>' +
			'<span class="help_high">Select</span>: Represents a &lt;select&gt;...&lt;/select&gt; element.<br>' +
			'<span class="help_high">Text</span>: Represents an &lt;input type="text"&gt; element.<br>' +
			'<span class="help_high">Submit</span>: Represents an &lt;input type="submit"&gt; element.<br>',
		user_field_use_fetch:
			'When an action is being executed, the PHP runtime creates an array index<br>' +
			'inside the <span class="help_high">$fields</span> pseudo-array, for each imported field definition. The<br>' +
			'<span class="help_high">Fetch</span> checkbox determines whether the PHP runtime will actually try to<br>' +
			'populate the field value from the <span class="help_high">$_GET</span>/<span class="help_high">$_POST</span>/<span class="help_high">$_FILES</span> array or will<br>' +
			'leave the field initialized with its default(empty) value. When the <span class="help_high">Fetch</span><br>' +
			'box is unchecked the field is left with its default value. When the <span class="help_high">Fetch</span><br>' +
			'box is checked the field value is fetched and saved into the <span class="help_high">$fields</span><br>' +
			'pseudo-array.',
		user_field_use_field_def_id:
			'Choose a field definition that will be imported into the current<br>' +
			'action. You can add new field definitions from the <span class="help_high">Fields</span> menu on<br>' +
			'the sidebar.',
		user_field_use_name:
			'Choose the name under which the field definition will be imported<br>' +
			'into the current action. The name must be at least 1 character long.<br>' +
			'It can contain letters (uppercase or lowercase), digits or underscores<br>' +
			'and must start with a letter (uppercase or lowercase) or an<br>' +
			'underscore.',
		user_forward_arg_name:
			'The forward argument name must be at least 1 character long. It<br>' +
			'can contain letters (uppercase or lowercase), digits or underscores<br>' +
			'and must start with a letter (uppercase or lowercase) or an<br>' +
			'underscore.',
		user_forward_def_name:
			'The forward definition name must be at least 1 character long. It<br>' +
			'can contain letters (uppercase or lowercase), digits or underscores<br>' +
			'and must start with a letter (uppercase or lowercase) or an<br>' +
			'underscore.',
		user_forward_def_object_action_id:
			'Choose the action that will be called via an HTTP redirect when the<br>' +
			'forward is invoked.',
		user_forward_def_object_template_def_id:
			'Choose the template that will be written to the standard output when<br>' +
			'the forward is invoked.',
		user_forward_def_type:
			'Choose the forward type. Currently five different forward types are<br>' +
			'supported:<br>' +
			'<span class="help_high">None</span>: Does nothing after the action handler returns control. This<br>' +
			'forward type is useful if you want to perform the necessary steps<br>' +
			'manually, i.e. send redirect headers via the PHP function <span class="help_high">header()</span> or<br>' +
			'write the HTML code to the standard output.<br>' +
			'<span class="help_high">Template</span>: Displays the specified template.<br>' +
			'<span class="help_high">Redirect(temporary)</span>: Sends a temporary HTTP redirect (code <span class="help_high">302</span>).<br>' +
			'<span class="help_high">Redirect(permanent)</span>: Sends a permanent HTTP redirect (code <span class="help_high">301</span>).<br>' +
			'<span class="help_high">Download</span>: Sends a user-defined Mime-Type header, followed by the<br>' +
			'actual binary data.',
		user_include_file:
			'Choose a PHP include file from your local filesystem to be uploaded. If you<br>' +
			'leave this field empty, then a zero-size PHP include file will be created.',
		user_include_name:
			'Put in this field the name under which the PHP include file will be saved in<br>' +
			'the PHP includes list. Only put the name part without the extension, e.g.<br>' +
			'just <span class="help_high">your_file</span>, instead of <span class="help_high">your_file.inc</span>.',
		user_list_def_name:
			'The list name must be at least 1 character long. It can contain<br>' +
			'letters (uppercase or lowercase), digits or underscores and must<br>' +
			'start with a letter (uppercase or lowercase) or an underscore.',
		user_list_def_persistent:
			'Persistent lists have key/value pairs that are statically configured and<br>' +
			'fetched from the database. Non-persistent lists do not have fixed elements<br>' +
			'and before being used they must be initialized with a call to <span class="help_high">lib_list::set(...)</span>.',
		user_list_element_key:
			'Put in this field the key of the list element. Keys can be random<br>' +
			'strings at least 1 character long, e.g. <span class="help_high">abcdef</span>. Please note that you<br>' +
			'do not have to enclose keys in single or double quotes.',
		user_list_element_value:
			'Put in this field the value of the list element. Values can be random strings<br>' +
			'at least 1 character long, e.g. <span class="help_high">abcdef</span>. Please note that you do not<br>' +
			'have to enclose the values in single or double quotes.',
		user_project_base_url_path:
			'The path component of the URL where your project will be installed.<br>' +
			'E.g. if your project will be installed to<br>' +
			'<span class="help_high">http://www.your-server-name.com/project/path</span>, then the base URL<br>' +
			'path will be <span class="help_high">/project/path/</span>. If the project will be installed to its own<br>' +
			'domain, e.g. <span class="help_high">http://subdomain.your-server.com</span>, then the base URL<br>' +
			'path will be <span class="help_high">/</span>. The base URL path is always an absolute one, i.e. it<br>' +
			'always starts with an <span class="help_high">/</span>. Also should always end with a <span class="help_high">/</span>.',
		user_project_db_database:
			'Put in this field the database name configured to be used by the<br>' +
			'compiled project. You can change it by editing<br>' +
			'<span class="help_high">include/generated/config.inc</span> inside the compiled project. Please<br>' +
			'note that this setting is not used when the project is run from<br>' +
			'the Advanced Website Creator.',
		user_project_db_engine:
			'Choose the database engine type.',
		user_project_db_host:
			'Put in this field the server hostname or IP address, e.g.<br>' +
			'<span class="help_high">db.your-server-name.com</span> or <span class="help_high">192.168.1.25</span>.<br>' +
			'You can change it by editing <span class="help_high">include/generated/config.inc</span><br>' +
			'inside the compiled project. Please note that this setting is<br>' +
			'not used when the project is run from the Advanced<br>' +
			'Website Creator. This field should not be left empty since<br>' +
			'in this case the database backend will usually fallback to<br>' +
			'a UNIX-domain connection mechanism.',
		user_project_db_mechanism:
			'Choose the mechanism used to connect to the database server.<br>' +
			'You can change it by editing <span class="help_high">include/generated/config.inc</span><br>' +
			'inside the compiled project. Please note that this setting is<br>' +
			'not used when the project is run from the Advanced Website<br>' +
			'Creator.',
		user_project_db_password:
			'Put in this field the database password configured to be used by<br>' +
			'the compiled project. You can change it by editing<br>' +
			'<span class="help_high">include/generated/config.inc</span> inside the compiled project. Please<br>' +
			'note that this setting is not used when the project is run from<br>' +
			'the Advanced Website Creator. If you leave this field empty,<br>' +
			'then the default database password will be used when connecting<br>' +
			'to the database server.',
		user_project_db_pathname:
			'Put in this field the database file pathname configured to be<br>' +
			'used by the compiled project. You can change it by editing<br>' +
			'<span class="help_high">include/generated/config.inc</span> inside the compiled project. Please<br>' +
			'note that this setting is not used when the project is run from<br>' +
			'the Advanced Website Creator.',
		user_project_db_port:
			'Put in this field the server port, e.g. <span class="help_high">1234</span>. You can<br>' +
			'change it by editing <span class="help_high">include/generated/config.inc</span><br>' +
			'inside the compiled project. Please note that this<br>' +
			'setting is not used when the project is run from the<br>' +
			'Advanced Website Creator. If you leave this field<br>' +
			'empty then a default value (which is different for<br>' +
			'different database backends) will be used when<br>' +
			'connecting to the database server.',
		user_project_db_socket_directory:
			'The directory where the PostgreSQL UNIX-domain socket<br>' +
			'is located. You can change it by editing<br>' +
			'<span class="help_high">include/generated/config.inc</span> inside the compiled project.<br>' +
			'Please note that this setting is not used when the project<br>' +
			'is run from the Advanced Website Creator. If you leave<br>' +
 			'this field empty, then a default value (usually <span class="help_high">/tmp/</span>)<br>' +
			'will be used when connecting to the database server.',
		user_project_db_socket_extension:
			'The extension of the PostgreSQL UNIX-domain socket file.<br>' +
			'You can change it by editing <span class="help_high">include/generated/config.inc</span><br>' +
			'inside the compiled project. Please note that this setting is<br>' +
			'not used when the project is run from the Advanced<br>' +
			'Website Creator. If you leave this field empty, then a<br>' +
			'default value is used (usually <span class="help_high">.5432</span>).',
		user_project_db_socket_file:
			'The pathname of the MySQL UNIX-domain socket. You<br>' +
			'can change it by editing <span class="help_high">include/generated/config.inc</span> inside<br>' +
			'the compiled project. Please note that this setting is not used<br>' +
			'when the project is run from the Advanced Website Creator.<br>' +
			'If you leave this field empty, then a default value is used<br>' +
			'(usually <span class="help_high">/tmp/mysql.sock</span>).',
		user_project_db_username:
			'Put in this field the database username configured to be used<br>' +
			'by the compiled project. You can change it by editing<br>' +
			'<span class="help_high">include/generated/config.inc</span> inside the compiled project. Please<br>' +
			'note that this setting is not used when the project is run from<br>' +
			'the Advanced Website Creator. If you leave this field empty,<br>' +
			'then the default database username will be used when<br>' +
			'connecting to the database server.',
		user_project_encode_expire_date:
			'Put in this field the date on which the compiled project<br>' +
			'will expire. The value must be in the following format<br>' +
			'<span class="help_high">YYYY-MM-DD</span>, where YYYY is the four-digit year (must<br>' +
			'be 1970 or greater), MM is the one or two-digit month<br>' +
			'number and DD is the one or two-digit day of month.<br>' +
			'E.g. if you put in this field 2010-02-10 then the<br>' +
			'compiled project will expire of Feb/10/2010 at<br>' +
			'00:00:00.',
		user_project_encode_expire_period:
			'The number of seconds, minutes, hours or days after which<br>' +
			'the compiled project will expire. The actual expire units are<br>' +
			'chosen from the <span class="help_high">Expire units</span> select box.',
		user_project_encode_expire_type:
			'Choose expire type of the encoded project. Following expire<br>' +
			'types are supported:<br>' +
			'<br>' +
			'<span class="help_high">Expire in a period</span>: The compiled project will expire in a<br>' +
			'specified number of seconds, minutes, hours or days after<br>' +
			'the moment when it has been compiled. Please note that<br>' +
			'for the Zend encoder expiry in a period is emulated via<br>' +
			'expiry on a date, so the actual expiry moment is always<br>' +
			'midnight of the calculated expire day. E.g. if you have a<br>' +
			'project that is configured to expire 48 hours after compile<br>' +
			'and you compile it at 15:30:10 on Feb/24/2007, then it<br>' +
			'will actually expire on Feb/26/2007 at 00:00:00 instead<br>' +
			'of on Feb/26/2007 at 15:30:10. This limitation does not<br>' +
			'exist if you are using the IonCube encoder.<br>' +
			'<span class="help_high">Expire on a date</span>: The compiled project will expire at<br>' +
			'00:00:00 on the specified date, regardless of the moment<br>' +
			'when it has been compiled.',
		user_project_encode_expire_unit:
			'Choose the actual time units in which is measured the<br>' +
			'expire period.',
		user_project_encode_type:
			'Choose the PHP encoder type.',
		user_project_file:
			'Choose a project file from your local filesystem to be uploaded. Project<br>' +
			'files have the extension <span class="help_high">.awc</span>.',
		user_project_layout_dir_htdocs:
			'This field contains the pathname of the website document<br>' +
			'root. The pathname is relative to the website run directory.<br>' +
			'The value must be a relative pathname which cannot point<br>' +
			'outside of the run directory. If you leave this field empty<br>' +
			'then the document root is assumed to be the same directory<br>' +
			'as the website run directory. Please note that this setting<br>' +
			'is not used when the project is run from the Advanced<br>' +
			'Website Creator.',
		user_project_layout_dir_system:
			'This field contains the pathname of the website system<br>' +
			'directory. The system directory contains directories and<br>' +
			'files that are used by the server-side code, but should<br>' +
			'not be directly accessible from the client web browser.<br>' +
			'The pathname in this field is relative to the website<br>' +
			'run directory, so it must be a relative pathname which<br>' +
			'cannot point outside of the run directory. If you leave<br>' +
			'this field empty then the system directory is assumed to<br>' +
			'be the same directory as the website run directory.<br>' +
			'Please note that this setting is not used when the project<br>' +
			'is run from the Advanced Website Creator.',
		user_project_layout_protect_system:
			'Check this box if you want to deny web clients access<br>' +
			'to the system directory. You need this protection only<br>' +
			'when the system directory is located inside the website<br>' +
			'document root. If the system directory is located outside<br>' +
			'of the document root, it is not accessible from the web,<br>' +
			'and there is no need to explicitly protect it. Protection<br>' +
			'of system directory is achieved by using a .htaccess file,<br>' +
			'so your website must allow usage of  .htaccess files in<br>' +
			'order for this protection mechanism to work correctly.<br>' +
			'Please note that this setting is not used when the<br>' +
			'project is run from the Advanced Website Creator.',
		user_project_layout_profile:
			'This box allows you to quickly select values for the other<br>' +
			'file layout fields. Following profiles are supported:<br>' +
			'<br>' +
			'<span class="help_high">Generic</span>: A generic layout that places the system<br>' +
			'directory inside the website document root. This layout<br>' +
			'will work on any server, but it has a couple of<br>' +
			'drawbacks:<br>' +
			'- You have to watch out when naming directory URLs<br>' +
			'so that they do not clash with the system directory.<br>' +
			'- If your webserver does not support .htaccess files,<br>' +
			'then contents of the system directory will be accessible<br>' +
			'from the client browser.<br>' +
			'<span class="help_high">AWC</span>: An AWC-specific layout, that places the system<br>' +
			'files in a directory outside of the website document root.<br>' +
			'<span class="help_high">Plesk</span>: A layout designed for websites using the Plesk<br>' +
			'control panel. The system files are placed in a Plesk<br>' +
			'specific directory called private/.',
		user_project_log:
			'Check this box if you want to enable the generation of a debug log in<br>' +
			'<span class="help_high">logs/debug.log</span> in the project run directory.',
		user_project_name:
			'The project name must be at least 1 character long.',
		user_project_prefer_aliases:
			'If you check this box then Advanced Website Creator will prefer action<br>' +
			'aliases to raw action URLs. This option affects redirect forwards, HTML<br>' +
			'templates and redirect definitions. If you want to use search engine<br>' +
			'friendly URLs then you should enable this option.',
		user_project_relocatable:
			'This setting specifies whether the compiled website<br>' +
			'will be able to work correctly after you move it to a<br>' +
			'URL pathname different from the base URL path.<br>' +
			'Unless you really need to build a relocatable website<br>' +
			'it is recommended to set this value to <span class="help_high">No</span> in order to<br>' +
			'speed up website compile and execution. For more<br>' +
			'details on this setting please see the manual.',
		user_template_file:
			'Choose a template file from your local filesystem to be uploaded. If you<br>' +
			'leave this field empty, then a zero-size template file will be created.',
		user_template_name:
			'Put in this field the name under which the template file will be saved in<br>' +
			'the templates list. Only put the name part without the extension, e.g.<br>' +
			'just <span class="help_high">your_file</span>, instead of <span class="help_high">your_file.tpl</span>.',
		user_url_def_name:
			'Put in this field one segment of the URL pathname. Please note that<br>' +
			'you cannot place multiple pathname segments in this field, e.g. you<br>' +
			'cannot add a URL called <span class="help_high">/documents/my_document.txt</span>. Instead you<br>' +
			'will have to create a directory <span class="help_high">documents</span> and then add inside that<br>' +
			'directory a data or text file called <span class="help_high">my_document.txt</span>',
		user_url_def_type:
			'Following URL types are supported:<br>' +
			'<br>' +
			'<span class="help_high">Directory</span>: A directory that can contain other URLs.<br>' +
			'<span class="help_high">Data</span>: A generic data file. Its contents are not altered in any way.<br>' +
			'<span class="help_high">Text</span>: A text file that can contain {URL:...} expansions which are<br>' +
			'processed during project compile.<br>' +
			'<span class="help_high">Permanent redirect</span>: This URL sends a permanent HTTP redirect<br>' +
			'(301) to the specified action or URL.<br>' +
			'<span class="help_high">Temporary redirect</span>: This URL sends a temporary HTTP redirect<br>' +
			'(302) to the specified action or URL.<br>' +
			'<span class="help_high">Alias</span>: This URL is internally replaced with the contents of a<br>' +
			'specified action or URL.<br>',
		user_url_def_file_data:
			'When creating a URL of type <span class="help_high">Data</span>, you must upload a file that contains<br>' +
			'the data<br>',
		user_url_def_file_text:
			'When creating a URL of type <span class="help_high">Text</span>, you can optionally upload a file that<br>' +
			'contains the text data. Any <span class="help_high">{URL:...}</span> expansions in that file are processed<br>' +
			'during project compile.',
		user_url_def_import_name:
			'Choose the name of a directory that will be created. This directory<br>' +
			'will contain all data files from the imported package.',
		user_url_def_import_package:
			'Choose a package that will have its files imported into the project.',
		user_url_def_target_type:
			'The target type of your redirect/alias. It can be either an action or an URL.<br>',
		user_url_def_target_action_id:
			'The target action to which this URL is redirected/aliased.',
		user_url_def_target_url_def_id:
			'The target URL to which this URL is redirected/aliased.',
		user_wiz_form_action_id:
			'This is the action under which all form objects (actions, fields,<br>' +
			'forwards and templates) will be inserted.',
		user_wiz_form_action_main:
			'This is the name of the main form action. You can change the<br>' +
			'pre-filled name in case it conflicts with another action name.',
		user_wiz_form_action_prompt:
			'This is the name of the action that is used to display the form<br>' +
			'initially. If the prompt action name conflicts with another action<br>' +
			'you can change the pre-filled name to something else.',
		user_wiz_form_action_submit:
			'This is the name of the action that is called when the user submits<br>' +
			'the form. If the submit action name conflicts with another action<br>' +
			'you can change the pre-filled name to something else.',
		user_wiz_form_forward_show:
			'This is the name of the action forward that shows the page template.<br>' +
			'If the forward name conflicts with another forward you can change<br>' +
			'the pre-filled name to something else.',
		user_wiz_form_forward_success:
			'This is the name of the action forward that is invoked after the form<br>' +
			'has been submitted and your custom code has finished processing.<br>' +
			'Please note that by default the success forward is of type NONE, so it<br>' +
			'just displays an empty page after form has been processed. You<br>' +
			'probably will want to change it to some other forward type (usually<br>' +
			'a template or redirect forward).',
		user_wiz_form_pseudo_field_def_id:
			'Choose a field definition that will be used by this field.',
		user_wiz_form_pseudo_field_text:
			'Enter a text description of the input field. This text<br>' +
			'will be displayed on the form page on the left side<br>' +
			'of the input field.',
		user_wiz_form_pseudo_field_name:
			'The input field name. It must be at least 1 character<br>' +
			'long. It can contain letters (uppercase or lowercase),<br>' +
			'digits or underscores and must start with a letter<br>' +
			'(uppercase or lowercase) or an underscore.',
		user_wiz_form_template:
			'This is the name of the page template that contains the form view.<br>' +
			'If the template name conflicts with another template you can change<br>' +
			'the pre-filled name to something else.',
		user_wiz_vade_add_action_main:
			'This is the name of the main record add action. If<br>' +
			'the action name conflicts with another action you<br>' +
			'can change the pre-filled name to something else.',
		user_wiz_vade_add_action_prompt:
			'This is the name of the action that is used to display the<br>' +
			'record add form initially. If the prompt action name conflicts<br>' +
			'with another action you can change the pre-filled name to<br>' +
			'something else.',
		user_wiz_vade_add_action_submit:
			'This is the name of the action that is called when the user<br>' +
			'submits the record add form. If the submit action name<br>' +
			'conflicts with another action you can change the pre-filled<br>' +
			'name to something else.',
		user_wiz_vade_add_enable:
			'Check this box if you want to allow addition of new records.',
		user_wiz_vade_add_forward_show:
			'This is the name of the action forward that shows the record add page<br>' +
			'template. If the forward name conflicts with another forward you can<br>' +
			'change the pre-filled name to something else.',
		user_wiz_vade_add_forward_success:
			'This forward is valid only when record listing is not allowed. In this<br>' +
			'case the success forward will be invoked by the submit action after a<br>' +
			'record has been added successfully. When record listing is allowed, the<br>' +
			'main list forward will be invoked instead.',
		user_wiz_vade_add_template_page:
			'This is the name of the page template that contains the view for<br>' +
			'the record add page. If the template name conflicts with another<br>' +
			'template you can change the pre-filled name to something else.',
		user_wiz_vade_delete_action:
			'This is the name of the record delete action. If the action<br>' +
			'name conflicts with another action you can change the<br>' +
			'pre-filled name to something else.',
		user_wiz_vade_delete_enable:
			'Check this box if you want to allow deletion of existing records.',
		user_wiz_vade_edit_action_main:
			'This is the name of the main record edit action. If<br>' +
			'the action name conflicts with another action you<br>' +
			'can change the pre-filled name to something else.',
		user_wiz_vade_edit_action_prompt:
			'This is the name of the action that is used to display the record edit<br>' +
			'form initially. If the submit action name conflicts with another action<br>' +
			'you can change the pre-filled name to something else.',
		user_wiz_vade_edit_action_submit:
			'This is the name of the action that is called when<br>' +
			'the user submits the record edit form. If the submit<br>' +
			'action name conflicts with another action you can<br>' +
			'change the pre-filled name to something else.',
		user_wiz_vade_edit_enable:
			'Check this box if you want to allow editing of existing records.',
		user_wiz_vade_edit_forward_show:
			'This is the name of the action forward that shows the<br>' +
			'record edit page template. If the forward name conflicts<br>' +
			'with another forward you can change the pre-filled name<br>' +
			'to something else.',
		user_wiz_vade_edit_template_page:
			'This is the name of the page template that contains the view for<br>' +
			'the record edit page. If the template name conflicts with another<br>' +
			'template you can change the pre-filled name to something else.',
		user_wiz_vade_list_action:
			'This is the name of the main action that handles record<br>' +
			'listing. If the action name conflicts with another action<br>' +
			'you can change the pre-filled name to something else.',
		user_wiz_vade_list_enable:
			'Check this box if you want to allow listing of records.',
		user_wiz_vade_list_forward_redirect:
			'This is the name of the main forward that will<br>' +
			'redirect the user to the list action.',
		user_wiz_vade_list_forward_show:
			'This is the name of the forward used to display the list page. If<br>' +
			'the forward name conflicts with another forward you can change<br>' +
			'the pre-filled name to something else.',
		user_wiz_vade_list_template_page:
			'This is the name of the template used by the list page. If the<br>' +
			'template name conflicts with another template you can change<br>' +
			'the pre-filled name to something else.',
		user_wiz_vade_main_action:
			'This is the name of the main action. You can change the pre-filled<br>' +
			'name in case it conflicts with another action name.',
		user_wiz_vade_main_parent_id:
			'This is the action under which all objects (actions, fields, forwards<br>' +
			'and templates) will be inserted.',
		user_wiz_vade_main_template_fields:
			'This is the name of the template file that will hold the add and edit<br>' +
			'form fields. You can change the pre-filled name in case it conflicts<br>' +
			'with another template name.',
		user_wiz_vade_pseudo_field_def_id:
			'Choose a field definition that will be used by this field.',
		user_wiz_vade_pseudo_field_name:
			'The input field name. It must be at least 1 character<br>' +
			'long. It can contain letters (uppercase or lowercase),<br>' +
			'digits or underscores and must start with a letter<br>' +
			'(uppercase or lowercase) or an underscore.',
		user_wiz_vade_pseudo_field_text:
			'Enter a text description of the input field. This text<br>' +
			'will be displayed on the form page on the left side<br>' +
			'of the input field.',
		user_wiz_vade_pseudo_field_in_listing:
			'Check this box if you want this field to appear on the<br>' +
			'listing page.',
		user_wiz_vade_record_field_def_id:
			'Choose the field definition that will be used for the<br>' +
			'record ID system field. In most cases you should<br>' +
			'choose a definition of an integer field type.',
		user_wiz_vade_record_id_field:
			'This is the name of the SQL primary key field.',
		user_wiz_vade_record_list_query:
			'This is the name of the query used to list SQL record fields.<br>' +
			'This query is valid only when record listing is allowed.',
		user_wiz_vade_record_table:
			'This is the name of the SQL table that will hold the added items.'
	}
};
