/*
Requires:
	class_menu_view.js
	functions_dom.js
	functions_event.js
*/

function text_editor (container_id, content, callback)
{
	var dom_container;

	this.callback = callback;
	this.is_modified = false;
	this.dom_top = null;
	this.dom_modified = null;
	this.dom_textarea = null;
	this.keymap_ignore = null;
	this.keymap_action = null;

	dom_container = document.getElementById (container_id);
	this._int_create_top (dom_container);
	this._int_create_textarea (dom_container, content);
	this._int_adjust_textarea ();
}

text_editor.prototype = {
	_int_create_top: function (dom_container) {
		var dom_row, dom_cell;

		this._int_create_top_menu (dom_container);
		this.dom_top = dom_container.getElementsByTagName ('div').item (0);
		dom_row = this.dom_top.getElementsByTagName ('tr').item (0);
		dom_cell = document.createElement ('td');
		this._int_create_top_modified (dom_cell);
		dom_row.insertBefore (dom_cell, dom_row.childNodes [0]);
	},

	_int_create_top_menu: function (dom_container) {
		var this_obj;

		this_obj = this;
		new menu_view (
			dom_container,
			[
				{item_id: 1, parent_id: null, text_left: '', text_right: ''},
				{item_id: 2, parent_id: 1, text_left: 'File', text_right: ''},
				{item_id: 3, parent_id: 2, text_left: 'Save', text_right: 'Ctrl-S'},
				{item_id: 4, parent_id: 2, text_left: 'Exit', text_right: 'Alt-X'}
			],
			{
				root_menu: 'menu_root_area',
				root_item_low: 'cursor_default menu_root_item_low',
				root_item_high: 'cursor_default menu_root_item_high',
				sub_menu: 'menu_sub_area',
				sub_item_low: 'cursor_default menu_sub_item_low',
				sub_item_high: 'cursor_default menu_sub_item_high'
			},
			function (item_id) {this_obj._int_menu_action (item_id);}
		);
	},

	_int_create_top_modified: function (dom_cell) {
		var dom_modified;

		dom_modified = document.createElement ('span');
		dom_modified.style.color = 'red';
		dom_modified.style.visibility = 'hidden';
		dom_modified.innerHTML = '*';
		dom_cell.style.width = '20px';
		dom_cell.style.textAlign = 'center';
		dom_cell.appendChild (dom_modified);
		this.dom_modified = dom_modified;
	},

	_int_menu_action: function (item_id) {
		switch (item_id) {
		case '3':
			this._int_action_save ();
			break;
		case '4':
			this._int_action_exit ();
			break;
		}
	},

	_int_create_textarea: function (dom_container, content) {
		var dom_textarea, this_obj, is_msie;

		this_obj = this;
		dom_textarea = document.createElement ('textarea');
		dom_textarea.style.border = '0px';
		dom_textarea.value = content;
		is_msie = ('event' in window);
		this.keymap_ignore = this._int_keymap_create (
			[
				{msie_key: 12, ff_key: 12, ff_char: 0, name: 'Keypad5', alt: null, ctrl: null, shift: null},
				{msie_key: 16, ff_key: 0, ff_char: 0, name: 'Shift', alt: null, ctrl: null, shift: null},
				{msie_key: 17, ff_key: 0, ff_char: 0, name: 'Control', alt: null, ctrl: null, shift: null},
				{msie_key: 18, ff_key: 0, ff_char: 0, name: 'Alt', alt: null, ctrl: null, shift: null},
				{msie_key: 19, ff_key: 19, ff_char: 0, name: 'Pause', alt: null, ctrl: null, shift: null},
				{msie_key: 20, ff_key: 0, ff_char: 0, name: 'CapsLock', alt: null, ctrl: null, shift: null},
				{msie_key: 33, ff_key: 33, ff_char: 0, name: 'PageUp', alt: null, ctrl: null, shift: null},
				{msie_key: 34, ff_key: 34, ff_char: 0, name: 'PageDown', alt: null, ctrl: null, shift: null},
				{msie_key: 35, ff_key: 35, ff_char: 0, name: 'End', alt: null, ctrl: null, shift: null},
				{msie_key: 36, ff_key: 36, ff_char: 0, name: 'Home', alt: null, ctrl: null, shift: null},
				{msie_key: 37, ff_key: 37, ff_char: 0, name: 'Left', alt: null, ctrl: null, shift: null},
				{msie_key: 38, ff_key: 38, ff_char: 0, name: 'Up', alt: null, ctrl: null, shift: null},
				{msie_key: 39, ff_key: 39, ff_char: 0, name: 'Right', alt: null, ctrl: null, shift: null},
				{msie_key: 40, ff_key: 40, ff_char: 0, name: 'Down', alt: null, ctrl: null, shift: null},
				{msie_key: 45, ff_key: 45, ff_char: 0, name: 'Insert', alt: false, ctrl: false, shift: false},
				{msie_key: 67, ff_key: 0, ff_char: 99, name: 'Copy', alt: false, ctrl: true, shift: false},
				{msie_key: 91, ff_key: 91, ff_char: 0, name: 'LeftWindows', alt: null, ctrl: null, shift: null},
				{msie_key: 92, ff_key: 92, ff_char: 0, name: 'RightWindows', alt: null, ctrl: null, shift: null},
				{msie_key: 93, ff_key: 93, ff_char: 0, name: 'ContextMenus', alt: null, ctrl: null, shift: null},
				{msie_key: 112, ff_key: 112, ff_char: 0, name: 'F1', alt: null, ctrl: null, shift: null},
				{msie_key: 113, ff_key: 113, ff_char: 0, name: 'F2', alt: null, ctrl: null, shift: null},
				{msie_key: 114, ff_key: 114, ff_char: 0, name: 'F3', alt: null, ctrl: null, shift: null},
				{msie_key: 115, ff_key: 115, ff_char: 0, name: 'F4', alt: null, ctrl: null, shift: null},
				{msie_key: 116, ff_key: 116, ff_char: 0, name: 'F5', alt: null, ctrl: null, shift: null},
				{msie_key: 117, ff_key: 117, ff_char: 0, name: 'F6', alt: null, ctrl: null, shift: null},
				{msie_key: 118, ff_key: 118, ff_char: 0, name: 'F7', alt: null, ctrl: null, shift: null},
				{msie_key: 119, ff_key: 119, ff_char: 0, name: 'F8', alt: null, ctrl: null, shift: null},
				{msie_key: 120, ff_key: 120, ff_char: 0, name: 'F9', alt: null, ctrl: null, shift: null},
				{msie_key: 121, ff_key: 121, ff_char: 0, name: 'F10', alt: null, ctrl: null, shift: null},
				{msie_key: 122, ff_key: 122, ff_char: 0, name: 'F11', alt: null, ctrl: null, shift: null},
				{msie_key: 123, ff_key: 123, ff_char: 0, name: 'F12', alt: null, ctrl: null, shift: null},
				{msie_key: 144, ff_key: 0, ff_char: 0, name: 'NumLock', alt: null, ctrl: null, shift: null},
				{msie_key: 145, ff_key: 0, ff_char: 0, name: 'ScrollLock, alt: null, ctrl: null, shift: null'}
			],
			is_msie
		);
		this.keymap_action = this._int_keymap_create (
			[
				{msie_key: 9, ff_key: 9, ff_char: 0, name: 'tab', alt: false, ctrl: false, shift: false},
				{msie_key: 83, ff_key: 0, ff_char: 115, name: 'save', alt: false, ctrl: true, shift: false},
				{msie_key: 88, ff_key: 0, ff_char: 120, name: 'exit', alt: true, ctrl: false, shift: false}
			],
			is_msie
		);
		event_handler_add (
			dom_textarea,
			is_msie ? 'keydown' : 'keypress',
			function (event) {this_obj._int_handle_key (event, is_msie);}
		);
		event_handler_add (
			window,
			'resize',
			function (event) {this_obj._int_adjust_textarea ();}
		);
		dom_container.appendChild (dom_textarea);
		dom_textarea.focus ();
		this.dom_textarea = dom_textarea;
	},

	_int_keymap_create: function (list, is_msie) {
		var keys, chars, i, item;

		keys = [];
		chars = is_msie ? null : [];
		for (i in list) {
			if (is_msie) {
				if (list [i]['msie_key'] != 0) {
					keys [list [i]['msie_key']] = {
						key: list [i]['msie_key'],
						char: null,
						name: list [i]['name'],
						alt: list [i]['alt'],
						ctrl: list [i]['ctrl'],
						shift: list [i]['shift']
					};
				}
			} else {
				item = {
					key: list [i]['ff_key'],
					char: list [i]['ff_char'],
					name: list [i]['name'],
					alt: list [i]['alt'],
					ctrl: list [i]['ctrl'],
					shift: list [i]['shift']
				};
				if (list [i]['ff_key'] != 0) {
					keys [list [i]['ff_key']] = item;
				}
				if (list [i]['ff_char'] != 0) {
					chars [list [i]['ff_char']] = item;
				}
			}
		}
		return ({keys: keys, chars: chars});
	},

	_int_keymap_lookup: function (map, event, is_msie) {
		var item;

		if (event.keyCode in map ['keys']) {
			item = map ['keys'][event.keyCode];
		} else if ((is_msie == false) && (event.charCode in map ['chars'])) {
			item = map ['chars'][event.charCode];
		} else {
			return (null);
		}
		if (
			(event.keyCode != item ['key']) ||
			((is_msie == false) && (event.charCode != item ['char']))
		) {
			return (null);
		}
		if ((item ['alt'] !== null) && (item ['alt'] !== event.altKey)) {
			return (null);
		}
		if ((item ['ctrl'] !== null) && (item ['ctrl'] !== event.ctrlKey)) {
			return (null);
		}
		if ((item ['shift'] !== null) && (item ['shift'] !== event.shiftKey)) {
			return (null);
		}
		return (item ['name']);
	},

	_int_handle_key: function (event, is_msie) {
		var action, modified;

		if (this._int_keymap_lookup (this.keymap_ignore, event, is_msie) !== null) {
			return;
		}
		if ((action = this._int_keymap_lookup (this.keymap_action, event, is_msie)) !== null) {
			modified = this._int_key_action (action);
			event_prevent_default (event);
		} else {
			modified = true;
		}
		this._int_set_modified (modified);
	},

	_int_key_action: function (action) {
		switch (action) {
		case 'tab':
			this._int_insert_text ('\t');
			return (true);
		case 'save':
			this._int_action_save ();
			return (false);
		case 'exit':
			this._int_action_exit ();
			return (false);
		default:
			alert ('Unexpected action');
			return (false);
		}
	},

	_int_insert_text: function (text) {
		var dom_textarea, scroll_left, scroll_top, new_pos;

		dom_textarea = this.dom_textarea;
		if ('setSelectionRange' in dom_textarea) {
			scroll_left = dom_textarea.scrollLeft;
			scroll_top = dom_textarea.scrollTop;
			new_pos = dom_textarea.selectionStart + text.length;
			dom_textarea.value =
				dom_textarea.value.substr (0, dom_textarea.selectionStart) +
				text +
				dom_textarea.value.substr (dom_textarea.selectionEnd);
			dom_textarea.setSelectionRange (new_pos, new_pos);
			dom_textarea.scrollLeft = scroll_left;
			dom_textarea.scrollTop = scroll_top;
		} else if ('selection' in document) {
			document.selection.createRange ().text = text;
		}
	},

	_int_action_save: function () {
		if (this.is_modified) {
			this.callback ('save', this.dom_textarea.value);
			this._int_set_modified (false);
		}
	},

	_int_action_exit: function () {
		if ((this.is_modified == false) || confirm ('Exit and lose unsaved data?')) {
			this.callback ('exit', null);
		}
	},

	_int_set_modified: function (is_modified) {
		if (this.is_modified != is_modified) {
			this.dom_modified.style.visibility = is_modified ? 'visible' : 'hidden';
			this.is_modified = is_modified;
		}
	},

	_int_adjust_textarea: function () {
		var this_obj;

		this._int_resize_textarea ();
		/*
			NB: If the user has shrunk the window, then on Firefox horizontal and/or
			vertical scrollbars have appeared for the page content. However after
			the first resize these scrollbars will disappear, leaving unused strips
			of space in the place of the scrollbars. To get rid of these strips we
			issue a second resize which is delayed because it must be done after
			the strips have appeared.
		*/
		this_obj = this;
		setTimeout (function () {this_obj._int_resize_textarea ();}, 0);
	},

	_int_resize_textarea: function () {
		var viewport;

		viewport = dom_get_viewport_size ();
		this.dom_textarea.style.width = (viewport.width - 2) + 'px';
		this.dom_textarea.style.height = (viewport.height - this.dom_top.offsetHeight - 4) + 'px';
	}
};
