function list_view (table_id, range_id, total_id, table_offset, table_num, list, row_builder)
{
	this.table_id = table_id;
	this.range_id = range_id;
	this.total_id = total_id;
	this.table_offset = table_offset;
	this.table_num = table_num;
	this.list = list;
	this._int_set_list_offset (0);
	this.row_builder = row_builder;
	this.visible = false;
}

list_view.prototype = {
	show: function () {
		if (this.visible != false) {
			return;
		}
		this.visible = true;
		this._int_update_view ();
		this._int_update_info ();
	},

	scroll: function (value) {
		if (this._int_set_list_offset (this.list_offset + value) == false) {
			return;
		}
		this._int_update_view ();
		this._int_update_info ();
	},

	_int_set_list_offset: function (offset) {
		var till_end;

		if (this._int_check_list_offset (offset) == false) {
			return (false);
		}
		this.list_offset = offset;
		till_end = this.list.length - this.list_offset;
		this.list_num = (till_end < this.table_num) ? till_end : this.table_num;
		return (true);
	},

	_int_check_list_offset: function (offset) {
		if ((offset >= 0) && (offset < this.list.length)) {
			return (true);
		}
		if ((offset == 0) && (this.list.length == 0)) {
			return (true);
		}
		return (false);
	},

	_int_update_view: function () {
		var dom_table, i;

		if (this.visible == false) {
			return;
		}
		dom_table = document.getElementById (this.table_id);
		i = 0;
		while (i < this.list_num) {
			this.row_builder (dom_table.rows [this.table_offset + i], this.list [this.list_offset + i]);
			++i
		}
		while (i < this.table_num) {
			this.row_builder (dom_table.rows [this.table_offset + i], null);
			++i
		}
	},

	_int_update_info: function () {
		var range;

		if (this.range_id) {
			if (this.list_num != 0) {
				range = String (this.list_offset + 1) + '-' + String (this.list_offset + this.list_num);
			} else {
				range = 'N/A';
			}
			document.getElementById (this.range_id).innerHTML = range;
		}
		if (this.total_id) {
			document.getElementById (this.total_id).innerHTML = this.list.length;
		}
	}
};
