function mouse_block ()
{
	this.block_obj = this._int_create_block ();
}

mouse_block.prototype = {
	start: function (dom_target) {
		if (this.block_obj === null) {
			return (false);
		}
		this.block_obj.start (dom_target);
		return (true);
	},

	stop: function () {
		if (this.block_obj === null) {
			return (false);
		}
		this.block_obj.stop ();
		return (true);
	},

	_int_create_block: function () {
		if (('addEventListener' in document) && ('removeEventListener' in document)) {
			return (new block_listener ());
		}
		if ('releaseCapture' in document) {
			return (new block_capture ());
		}
		return (null);
	}
};

function block_listener ()
{
	this.dom_target = null;
	this.handler_mousedown = null;
	this.handler_mouseup = null;
	this.handler_mousemove = null;
	this.handler_click = null;
	this.handler_dblclick = null;
	this.handler_mouseover = null;
	this.handler_mouseout = null;
}

block_listener.prototype = {
	start: function (dom_target) {
		this.dom_target = dom_target;
		this._int_add_handler ('mousedown');
		this._int_add_handler ('mouseup');
		this._int_add_handler ('mousemove');
		this._int_add_handler ('click');
		this._int_add_handler ('dblclick');
		this._int_add_handler ('mouseover');
		this._int_add_handler ('mouseout');
	},

	stop: function () {
		this._int_remove_handler ('mousedown');
		this._int_remove_handler ('mouseup');
		this._int_remove_handler ('mousemove');
		this._int_remove_handler ('click');
		this._int_remove_handler ('dblclick');
		this._int_remove_handler ('mouseover');
		this._int_remove_handler ('mouseout');
		this.dom_target = null;
	},

	_int_add_handler: function (name) {
		var this_obj, handler;

		this_obj = this;
		handler = function (event) {
			if (this_obj._int_contains (this_obj.dom_target, event.target) == false) {
				event.stopPropagation ();
				event.preventDefault ();
			}
		};
		document.addEventListener (name, handler, true);
		this ['handler_' + name] = handler;
	},

	_int_remove_handler: function (name) {
		document.removeEventListener (name, this ['handler_' + name], true);
		this ['handler_' + name] = null;
	},

	_int_contains: function (dom_container, dom_element) {
		while (dom_element) {
			if (dom_element === dom_container) {
				return (true);
			}
			dom_element = dom_element.parentNode;
		}
		return (false);
	}
};

/*
   FIXME: Must find a way to really block all mouse events on IE6 for DOM
   elements that do not belong to the specified DOM element.
*/
function block_capture ()
{
}

block_capture.prototype = {
	start: function (dom_target) {
		dom_target.setCapture (false);
	},

	stop: function () {
		document.releaseCapture ();
	}
};
