function style_input_file (input_id, info)
{
	var dom_input;

	dom_input = document.getElementById (input_id);
	dom_styled = this._int_get_styled (dom_input, info);
	dom_input.parentNode.replaceChild (dom_styled, dom_input);
}

style_input_file.prototype = {
	_int_get_styled: function (dom_input, info) {
		var dom_span, dom_file, dom_fake, dom_item;

		dom_span = document.createElement ('span');
		dom_span.style.position = 'relative';
		dom_file = this._int_get_file (dom_input);
		dom_span.appendChild (dom_file);
		dom_faked = this._int_get_faked (info);
		dom_span.appendChild (dom_faked);
		this._int_intercept_changes (dom_file, dom_faked);
		return (dom_span);
	},

	_int_get_file: function (dom_input) {
		var dom_file;

		/*
			NB: Under Firefox changing the width of an <input type="file">
			does not change the look of the input element, although it
			affects the space allocated for the input element and
			the positioning of the neighbouring elements. This using a
			style="width: 1000px;" will not change the input element but
			will leave whitespace on the right from the input.
			This should be taken into account when choosing the style for
			the real <input type="file">.
		*/
		dom_file = dom_input.cloneNode (false);
		dom_file.style.position = 'relative';
		dom_file.style.left = '0px';
		dom_file.style.top = '0px';
		dom_file.style.zIndex = '2';
		dom_file.style.MozOpacity = '0';
		dom_file.style.filter = 'alpha(opacity: 0)';
		return (dom_file);
	},

	_int_get_faked: function (info) {
		var dom_fake, dom_item;

		dom_fake = document.createElement ('span');
		dom_fake.style.position = 'absolute';
		dom_fake.style.left = '0px';
		dom_fake.style.top = '0px';
		dom_fake.style.zIndex = '1';
		dom_item = document.createElement ('input');
		dom_item.type = 'text';
		if (info ['input_style'] !== null) {
			dom_item.className = info ['input_style'];
		}
		dom_item.style.verticalAlign = 'top';
		dom_fake.appendChild (dom_item);
		dom_item = document.createElement ('img');
		dom_item.src = info ['button_url'];
		if (info ['button_style'] !== null) {
			dom_item.className = info ['button_style'];
		}
		dom_item.style.verticalAlign = 'top';
		dom_fake.appendChild (dom_item);
		return (dom_fake);
	},

	_int_intercept_changes: function (dom_file, dom_faked) {
		var dom_input, handler;

		dom_input = dom_faked.getElementsByTagName ('input').item (0);
		handler = function () {dom_input.value = dom_file.value;};
		event_handler_add (dom_file, 'change', handler);
		event_handler_add (dom_file, 'keyup', handler);
	}
};
