function dom_update_select (select_id, options, value)
{
	var dom_select, dom_clone, i, dom_option;

	dom_select = document.getElementById (select_id);
	/*
	   NB: We have to modify the cloned object, because modifying the
	   original DOM object for <select> produces blinking on IE6.
	   This way on IE6 there is only one blink when the original
	   object is replaced with its clone.
	*/
	dom_clone = dom_select.cloneNode (false);
	for (i in options) {
		dom_option = document.createElement ('option');
		dom_option.value = i;
		dom_option.appendChild (document.createTextNode (options [i]));
		dom_option.selected = (value !== null) && (i == value);
		dom_clone.appendChild (dom_option);
	}
	dom_select.parentNode.replaceChild (dom_clone, dom_select);
}

/*
	FIXME:
		1. Must return null for objects not inserted in the document tree.
		2. Must add a workaround for an IE5.5+ bug for elements with
		   "position: relative" which causes incorrect values in
		   offsetLeft and offsetTop.
*/
function dom_get_position (dom_obj)
{
	var x, y, dom_element;

	x = 0;
	y = 0;
	dom_element = dom_obj;
	/*
	   NB:
	      In IE6 the <html> DOM element is the topmost element when walking the offsetParent chain. However its
	      offsetParent element is quite weird. typeof(dom_html.offsetParent) returns 'object', but at the same time
	      (dom_html.offsetParent === null) is true. The visual studio debugger shows its value as null.

	   NB:
	      In IE6 DOM elements which are not inserted into the document tree have a weird
	      offsetParent property. ('offsetParent' in element) evaluates to true,
	      typeof(element.offsetParent) returns 'unknown' and every attempt to read this
	      offsetParent property results an unspecified javascript error.
	*/
	while (
		(typeof (dom_element) == 'object') &&
		(dom_element !== null) &&
		('offsetParent' in dom_element) &&
		(typeof (dom_element.offsetParent) != 'unknown')
	) {
		x += dom_element.offsetLeft;
		y += dom_element.offsetTop;
		dom_element = dom_element.offsetParent;
	}
	return ({x: x, y: y});
}

function dom_get_document_scroll ()
{
	if (
		(document.documentElement.scrollTop != 0) ||
		(document.documentElement.scrollLeft != 0)
	) {
		return ({
			x: document.documentElement.scrollLeft,
			y: document.documentElement.scrollTop
		});
	}
	if (
		(document.body.scrollTop != 0) ||
		(document.body.scrollLeft != 0)
	) {
		return ({
			x: document.body.scrollLeft,
			y: document.body.scrollTop
		});
	}
	return ({x: 0, y: 0});
}

function dom_set_radio_buttons (button_ids, value)
{
	var i, dom_obj;

	for (i in button_ids) {
		dom_obj = document.getElementById (button_ids [i]);
		dom_obj.checked = (dom_obj.value == value);
	}
}

function dom_get_radio_buttons (button_ids)
{
	var i, dom_obj;

	for (i in button_ids) {
		dom_obj = document.getElementById (button_ids [i]);
		if (dom_obj.checked) {
			return (dom_obj.value);
		}
	}
	return (null);
}

function dom_get_viewport_size ()
{
	var info_obj;

	info_obj =
		(document.compatMode != 'BackCompat') ?
		document.documentElement :
		document.body;
	return ({
		width: info_obj.clientWidth,
		height: info_obj.clientHeight
	});
}
