CREATE FUNCTION public.get_pathname (varchar, varchar, varchar, varchar, varchar, varchar, int) RETURNS varchar AS '
DECLARE
	tbl ALIAS FOR $1;
	id_field ALIAS FOR $2;
	owner_field ALIAS FOR $3;
	left_field ALIAS FOR $4;
	right_field ALIAS FOR $5;
	name_field ALIAS FOR $6;
	item_id ALIAS FOR $7;
	one_row record;
	result varchar;
BEGIN
	
	result := \'\';
	FOR one_row IN EXECUTE
		\'SELECT \' || name_field || \' AS name \' ||
		\'FROM \' || tbl || \' \' ||
		\'WHERE \' ||
			left_field || \' <= (\' ||
				\'SELECT \' || left_field || \' \' ||
				\'FROM \' || tbl || \' \' ||
				\'WHERE \' || id_field || \'=\\\'\' || item_id || \'\\\'\' ||
			\') AND \' ||
			right_field || \' >= (\' ||
				\'SELECT \' || left_field || \' \' ||
				\'FROM \' || tbl || \' \' ||
				\'WHERE \' || id_field || \'=\\\'\' || item_id || \'\\\'\' ||
			\') AND \' ||
			owner_field || \' = (\' ||
				\'SELECT \' || owner_field || \' \' ||
				\'FROM \' || tbl || \' \' ||
				\'WHERE \' || id_field || \'=\\\'\' || item_id || \'\\\'\' ||
			\')\' ||
		\'ORDER BY \' || left_field || \' ASC \' ||
		\'OFFSET 1\'
	LOOP
		result := result || \'/\' || one_row.name;
	END LOOP;
	IF result = \'\' THEN
		result := \'/\';
	END IF;
	RETURN result;

END
' LANGUAGE 'plpgsql' VOLATILE;
CREATE FUNCTION public.action_get_pathname (int) RETURNS varchar AS '
DECLARE
	item_id ALIAS FOR $1;
BEGIN
	
	RETURN get_pathname (\'actions\', \'action_id\', \'project_id\', \'num_left\', \'num_right\', \'name\', item_id);

END
' LANGUAGE 'plpgsql' VOLATILE;
CREATE FUNCTION public.url_def_get_pathname (int) RETURNS varchar AS '
DECLARE
	item_id ALIAS FOR $1;
BEGIN
	
	RETURN get_pathname (\'url_defs\', \'url_def_id\', \'project_id\', \'num_left\', \'num_right\', \'name\', item_id);

END
' LANGUAGE 'plpgsql' VOLATILE;
CREATE SEQUENCE public.action_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.action_id', 1, false);
CREATE SEQUENCE public.constant_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.constant_id', 1, false);
CREATE SEQUENCE public.field_check_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.field_check_id', 1, false);
CREATE SEQUENCE public.field_def_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.field_def_id', 1, false);
CREATE SEQUENCE public.field_use_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.field_use_id', 1, false);
CREATE SEQUENCE public.forward_arg_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.forward_arg_id', 1, false);
CREATE SEQUENCE public.forward_def_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.forward_def_id', 1, false);
CREATE SEQUENCE public.include_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.include_id', 1, false);
CREATE SEQUENCE public.language_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.language_id', 1, false);
CREATE SEQUENCE public.list_def_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.list_def_id', 1, false);
CREATE SEQUENCE public.list_element_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.list_element_id', 1, false);
CREATE SEQUENCE public.project_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.project_id', 1, false);
CREATE SEQUENCE public.template_def_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.template_def_id', 1, false);
CREATE SEQUENCE public.template_piece_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.template_piece_id', 1, false);
CREATE SEQUENCE public.url_def_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.url_def_id', 1, false);
CREATE SEQUENCE public.url_piece_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.url_piece_id', 1, false);
CREATE SEQUENCE public.user_id INCREMENT 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1;
SELECT setval('public.user_id', 1, false);
CREATE TABLE public._fwk_list_defs (
	list_def_id int NOT NULL,
	name varchar(64) NOT NULL,
	persistent bool NOT NULL,
	PRIMARY KEY(list_def_id)
) WITHOUT OIDS;
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('1', 'action', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('2', 'db_engine', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('3', 'db_mechanism', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('4', 'encode_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('5', 'encode_expire_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('6', 'encode_expire_unit', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('7', 'field_def', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('8', 'field_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('9', 'field_source', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('10', 'field_check', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('11', 'forward_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('12', 'list_def', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('13', 'package', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('14', 'relocatable', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('15', 'rewrite_target_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('16', 'rewrite_target', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('17', 'session_type', '1');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('18', 'template_def', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('19', 'url_def', '0');
INSERT INTO _fwk_list_defs (list_def_id, name, persistent) VALUES ('20', 'url_type', '1');
CREATE TABLE public._fwk_list_elements (
	list_element_id int NOT NULL,
	list_def_id int NOT NULL,
	sort_key int NOT NULL,
	item_key varchar(64) NOT NULL,
	item_value text NOT NULL,
	PRIMARY KEY(list_element_id)
) WITHOUT OIDS;
CREATE INDEX _fwk_list_elements_list_def_id_index ON _fwk_list_elements (list_def_id);
CREATE INDEX _fwk_list_elements_sort_key_index ON _fwk_list_elements (sort_key);
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('1', '2', '0', '1', 'MySQL');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('2', '2', '1', '2', 'PostgreSQL');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('3', '2', '2', '3', 'SQLite');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('4', '3', '0', '1', 'UNIX domain socket');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('5', '3', '1', '2', 'TCP socket');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('6', '4', '0', '1', 'None');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('7', '4', '1', '2', 'Zend');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('8', '4', '2', '3', 'IonCube');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('9', '5', '0', '1', 'None');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('10', '5', '1', '2', 'Expire in a period');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('11', '5', '2', '3', 'Expire on a date');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('12', '6', '0', '1', 'Seconds');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('13', '6', '1', '2', 'Minutes');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('14', '6', '2', '3', 'Hours');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('15', '6', '3', '4', 'Days');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('16', '8', '0', '1', 'Area');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('17', '8', '1', '2', 'Checkbox');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('18', '8', '2', '3', 'File');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('19', '8', '3', '4', 'Hidden');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('20', '8', '4', '5', 'Image');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('21', '8', '5', '6', 'Multibox');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('22', '8', '6', '7', 'Password');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('23', '8', '7', '8', 'Select');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('24', '8', '8', '9', 'Text');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('25', '8', '9', '10', 'Submit');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('26', '9', '0', '1', 'GET');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('27', '9', '1', '2', 'POST');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('28', '10', '0', '1', 'Integer');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('29', '10', '1', '2', 'Length');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('30', '10', '2', '3', 'List');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('31', '10', '3', '4', 'PCRE');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('32', '10', '4', '5', 'Upload');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('33', '11', '0', '1', 'None');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('34', '11', '1', '2', 'Template');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('35', '11', '2', '3', 'Redirect (temporary)');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('36', '11', '3', '4', 'Redirect (permanent)');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('37', '11', '4', '5', 'Download');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('38', '14', '0', '1', 'No');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('39', '14', '1', '2', 'Partially');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('40', '14', '2', '3', 'Fully');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('41', '15', '0', '1', 'Action');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('42', '15', '1', '2', 'URL');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('43', '17', '0', '1', 'None');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('44', '17', '1', '2', 'Read');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('45', '17', '2', '3', 'Read/Write');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('46', '20', '0', '1', 'Directory');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('47', '20', '1', '2', 'Data');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('48', '20', '2', '3', 'Text');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('49', '20', '3', '4', 'Redirect (permanent)');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('50', '20', '4', '5', 'Redirect (temporary)');
INSERT INTO _fwk_list_elements (list_element_id, list_def_id, sort_key, item_key, item_value) VALUES ('51', '20', '5', '6', 'Alias');
CREATE TABLE public._fwk_sessions (
	session_id varchar(32) NOT NULL,
	access_time timestamp NOT NULL,
	serialized text NOT NULL,
	PRIMARY KEY(session_id)
) WITHOUT OIDS;
CREATE INDEX _fwk_sessions_access_time_index ON _fwk_sessions (access_time);
CREATE TABLE public.admins (
	admin_id int NOT NULL,
	username text NOT NULL,
	password text NOT NULL,
	PRIMARY KEY(admin_id)
) WITHOUT OIDS;
CREATE INDEX admins_username_index ON admins (username);
CREATE INDEX admins_password_index ON admins (password);
INSERT INTO admins (admin_id, username, password) VALUES ('1', 'admin', 'admin');
CREATE TABLE public.actions (
	action_id int NOT NULL,
	project_id int NOT NULL,
	parent_id int,
	num_left int NOT NULL,
	num_right int NOT NULL,
	name text,
	handler text,
	session int NOT NULL,
	cache bool NOT NULL,
	PRIMARY KEY(action_id)
) WITHOUT OIDS;
CREATE INDEX actions_project_id_index ON actions (project_id);
CREATE INDEX actions_parent_id_index ON actions (parent_id);
CREATE INDEX actions_num_left_index ON actions (num_left);
CREATE INDEX actions_num_right_index ON actions (num_right);
CREATE TABLE public.constants (
	constant_id int NOT NULL,
	project_id int NOT NULL,
	name text NOT NULL,
	value text NOT NULL,
	PRIMARY KEY(constant_id)
) WITHOUT OIDS;
CREATE INDEX constants_project_id_index ON constants (project_id);
CREATE TABLE public.field_checks (
	field_check_id int NOT NULL,
	field_def_id int NOT NULL,
	sort_key int NOT NULL,
	check_type int NOT NULL,
	message text,
	check_text text,
	check_int_1 int,
	check_int_2 int,
	PRIMARY KEY(field_check_id)
) WITHOUT OIDS;
CREATE INDEX field_checks_field_def_id_index ON field_checks (field_def_id);
CREATE INDEX field_checks_sort_key_index ON field_checks (sort_key);
CREATE TABLE public.field_defs (
	field_def_id int NOT NULL,
	project_id int NOT NULL,
	name text NOT NULL,
	field_type int NOT NULL,
	source int,
	list_def_id int,
	list_initial text,
	PRIMARY KEY(field_def_id)
) WITHOUT OIDS;
CREATE INDEX field_defs_project_id_index ON field_defs (project_id);
CREATE TABLE public.field_uses (
	field_use_id int NOT NULL,
	action_id int NOT NULL,
	field_def_id int NOT NULL,
	sort_key int NOT NULL,
	name text NOT NULL,
	fetch bool NOT NULL,
	PRIMARY KEY(field_use_id)
) WITHOUT OIDS;
CREATE INDEX field_uses_action_id_index ON field_uses (action_id);
CREATE INDEX field_uses_field_def_id_index ON field_uses (field_def_id);
CREATE INDEX field_uses_sort_key_index ON field_uses (sort_key);
CREATE TABLE public.forward_args (
	forward_arg_id int NOT NULL,
	forward_def_id int NOT NULL,
	sort_key int NOT NULL,
	name text NOT NULL,
	PRIMARY KEY(forward_arg_id)
) WITHOUT OIDS;
CREATE INDEX forward_args_forward_def_id_index ON forward_args (forward_def_id);
CREATE INDEX forward_args_sort_key_index ON forward_args (sort_key);
CREATE TABLE public.forward_defs (
	forward_def_id int NOT NULL,
	action_id int NOT NULL,
	name text NOT NULL,
	forward_type int NOT NULL,
	object_id int,
	PRIMARY KEY(forward_def_id)
) WITHOUT OIDS;
CREATE INDEX forward_defs_action_id_index ON forward_defs (action_id);
CREATE INDEX forward_defs_object_id_index ON forward_defs (object_id);
CREATE TABLE public.includes (
	include_id int NOT NULL,
	project_id int NOT NULL,
	name text NOT NULL,
	update_time timestamptz NOT NULL,
	data text NOT NULL,
	PRIMARY KEY(include_id)
) WITHOUT OIDS;
CREATE INDEX includes_project_id_index ON includes (project_id);
CREATE TABLE public.languages (
	language_id int NOT NULL,
	name text NOT NULL,
	PRIMARY KEY(language_id)
) WITHOUT OIDS;
CREATE TABLE public.list_defs (
	list_def_id int NOT NULL,
	project_id int NOT NULL,
	name text NOT NULL,
	persistent bool NOT NULL,
	PRIMARY KEY(list_def_id)
) WITHOUT OIDS;
CREATE INDEX list_defs_project_id_index ON list_defs (project_id);
CREATE TABLE public.list_elements (
	list_element_id int NOT NULL,
	list_def_id int NOT NULL,
	sort_key int NOT NULL,
	item_key text NOT NULL,
	item_value text NOT NULL,
	PRIMARY KEY(list_element_id)
) WITHOUT OIDS;
CREATE INDEX list_elements_list_def_id_index ON list_elements (list_def_id);
CREATE INDEX list_elements_sort_key_index ON list_elements (sort_key);
CREATE TABLE public.projects (
	project_id int NOT NULL,
	user_id int NOT NULL,
	name text NOT NULL,
	base_url_path text NOT NULL,
	log bool NOT NULL,
	prefer_aliases bool NOT NULL,
	relocatable int NOT NULL,
	encode_type int NOT NULL,
	encode_expire_type int,
	encode_expire_value int,
	encode_expire_unit int,
	layout_dir_htdocs text NOT NULL,
	layout_dir_system text NOT NULL,
	layout_protect_system bool NOT NULL,
	db_engine int NOT NULL,
	db_mechanism int,
	db_connect_1 text,
	db_connect_2 text,
	db_username text,
	db_password text,
	db_database text,
	db_definition text NOT NULL,
	PRIMARY KEY(project_id)
) WITHOUT OIDS;
CREATE INDEX projects_user_id_index ON projects (user_id);
CREATE TABLE public.settings (
	setting_id int NOT NULL,
	dir_temp text NOT NULL,
	pathname_zend text,
	pathname_ioncube text,
	run_dir text NOT NULL,
	run_url text NOT NULL,
	layout_dir_htdocs text NOT NULL,
	layout_dir_system text NOT NULL,
	layout_protect_system bool NOT NULL,
	mysql_use bool NOT NULL,
	mysql_mechanism int,
	mysql_connect_1 text,
	mysql_connect_2 text,
	mysql_admin_username text,
	mysql_admin_password text,
	mysql_client_host text,
	postgresql_use bool NOT NULL,
	postgresql_mechanism int,
	postgresql_connect_1 text,
	postgresql_connect_2 text,
	postgresql_admin_username text,
	postgresql_admin_password text,
	sqlite_use bool NOT NULL,
	sqlite_pathname text,
	PRIMARY KEY(setting_id)
) WITHOUT OIDS;
CREATE TABLE public.template_defs (
	template_def_id int NOT NULL,
	action_id int NOT NULL,
	name text NOT NULL,
	update_time timestamptz NOT NULL,
	PRIMARY KEY(template_def_id)
) WITHOUT OIDS;
CREATE INDEX template_defs_action_id_index ON template_defs (action_id);
CREATE TABLE public.template_pieces (
	template_piece_id int NOT NULL,
	template_def_id int NOT NULL,
	sort_key int NOT NULL,
	piece_type int NOT NULL,
	object_id int,
	data_1 text,
	data_2 text,
	PRIMARY KEY(template_piece_id)
) WITHOUT OIDS;
CREATE INDEX template_pieces_template_def_id_index ON template_pieces (template_def_id);
CREATE INDEX template_pieces_sort_key_index ON template_pieces (sort_key);
CREATE INDEX template_pieces_object_id_index ON template_pieces (object_id);
CREATE TABLE public.url_defs (
	url_def_id int NOT NULL,
	project_id int NOT NULL,
	parent_id int,
	num_left int NOT NULL,
	num_right int NOT NULL,
	name text,
	update_time timestamptz NOT NULL,
	url_type int NOT NULL,
	data bytea,
	target_type int,
	target_id int,
	PRIMARY KEY(url_def_id)
) WITHOUT OIDS;
CREATE INDEX url_defs_project_id_index ON url_defs (project_id);
CREATE INDEX url_defs_parent_id_index ON url_defs (parent_id);
CREATE INDEX url_defs_num_left_index ON url_defs (num_left);
CREATE INDEX url_defs_num_right_index ON url_defs (num_right);
CREATE TABLE public.url_pieces (
	url_piece_id int NOT NULL,
	url_def_id int NOT NULL,
	sort_key int NOT NULL,
	piece_type int NOT NULL,
	object_id int,
	data text,
	PRIMARY KEY(url_piece_id)
) WITHOUT OIDS;
CREATE INDEX url_pieces_url_def_id_index ON url_pieces (url_def_id);
CREATE INDEX url_pieces_sort_key_index ON url_pieces (sort_key);
CREATE INDEX url_pieces_object_id_index ON url_pieces (object_id);
CREATE TABLE public.users (
	user_id int NOT NULL,
	username text NOT NULL,
	password text NOT NULL,
	PRIMARY KEY(user_id)
) WITHOUT OIDS;
CREATE INDEX users_username_index ON users (username);
CREATE INDEX users_password_index ON users (password);
