<?php
class url_relative_path
{
	static public function reference ($dest_segments, $src_segments, $min_diffs)
	{
		$src_num = count ($src_segments);
		$dest_num = count ($dest_segments);
		for (
			$i = 0, $n = min ($src_num, $dest_num);
			$i < $n;
			++$i
		) {
			if ($src_segments [$i] != $dest_segments [$i]) {
				break;
			}
		}
		$levels_up = $src_num - $i;
		if (($min_diffs !== null) && ($min_diffs > $levels_up)) {
			$levels_up = $min_diffs;
		}
		if ($levels_up == 0) {
			/*
				NB:
				1. A special case: a URL references itself. We do not have
				to check if lengths of two segment lists match since no
				segment list can be a prefix of another segment list.
				2. We cannot just use an empty URL since IE has a bug which
				causes it to treat empty URLs as references to the current
				hierarchy level instead of as references to the current
				document. However the last source segment is empty then it
				should be OK under IE since in this case the current document
				is the current hierarchy level.
			*/
			return (end ($src_segments));
		}
		if (
			($levels_up == 1) &&
			($src_num == $dest_num) &&
			(end ($dest_segments) == "")
		) {
			/* NB: A special case: a URL references its current hierarchy level */
			return ("./");
		}
		return (
			str_repeat ("../", $levels_up - 1) .
			implode ("/", array_slice ($dest_segments, $src_num - $levels_up))
		);
	}
}
?>
