<?php
class lib_list
{
	static private $list_defs = null;
	static private $lists = null;

	static public function get ($name)
	{
		self::_int_load_defs ();
		self::_int_load_list ($name);
		return (self::$lists [$name]);
	}

	static public function set ($name, $list)
	{
		self::_int_load_defs ();
		self::_int_set_list ($name, $list);
	}

	static private function _int_load_defs ()
	{
		if (self::$list_defs !== null) {
			return;
		}
		$rows = lib_db::query_raw (
			"SELECT list_def_id, name, persistent " .
			"FROM _fwk_list_defs"
		);
		self::$list_defs = array ();
		foreach ($rows as $one_row) {
			self::$list_defs [$one_row ["name"]] = array (
				"list_def_id" => $one_row ["list_def_id"],
				/*
					FIXME: Must implement a unified library used for
					PHP <--> SQL value conversion and use it here.
				*/
				"persistent" =>
					($one_row ["persistent"] == "t") ||
					($one_row ["persistent"] == "1")
			);
		}
		self::$lists = array ();
	}

	static private function _int_load_list ($name)
	{
		if (array_key_exists ($name, self::$lists)) {
			return;
		}
		if (array_key_exists ($name, self::$list_defs) == false) {
			lib_event::fatal ("Attempt to load an unknown list \"%s\"", $name);
		}
		if (self::$list_defs [$name]["persistent"] == false) {
			lib_event::fatal ("Attempt to load a non-persistent list \"%s\"", $name);
		}
		$rows = lib_db::query_raw (
			"SELECT item_key, item_value " .
			"FROM _fwk_list_elements " .
			"WHERE list_def_id='" . lib_db::escape (self::$list_defs [$name]["list_def_id"]) . "' " .
			"ORDER BY sort_key ASC"
		);
		$list = array ();
		foreach ($rows as $one_row) {
			$list [$one_row ["item_key"]] = $one_row ["item_value"];
		}
		self::$lists [$name] = $list;
	}

	static private function _int_set_list ($name, $list)
	{
		if (array_key_exists ($name, self::$list_defs) == false) {
			lib_event::fatal ("Attempt to set an unknown list \"%s\"", $name);
		}
		if (self::$list_defs [$name]["persistent"]) {
			lib_event::fatal ("Attempt to set a persistent list \"%s\"", $name);
		}
		self::$lists [$name] = $list;
	}
}
?>
