<?php
class lib_misc
{
	static private $windows = null;

	static public function is_windows ()
	{
		if (self::$windows === null) {
			self::$windows =
				array_key_exists ("OS", $_ENV) &&
				(stripos ($_ENV ["OS"], "win") !== false);
		}
		return (self::$windows);
	}

	static public function escape_php_string ($string)
	{
		return (addcslashes ($string, "\\\"\$"));
	}

	static public function escape_pcre_string ($string)
	{
		/*
			NB: The list of metacharacters is taken from the PCRE
			manual pages at http://pcre.org/pcre.txt
		*/
		return (addcslashes ($string, "\\^\$.[|()?*+{"));
	}

	static public function generate_hash ($length)
	{
		static $int_to_char = array (
			"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H",
			"I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"
		);

		$n = count ($int_to_char) - 1;
		$hash = "";
		for($i = 0; $i < $length; ++$i) {
			$random = floor (mt_rand (0, $n));
			$hash .= $int_to_char [$random];
		}
		return ($hash);
	}

	/* NB: This method implements a very ineffective way of checking if a given eregi expression is valid */
	static public function is_valid_eregi ($expr)
	{
		$old_error_reporting = ini_get ("error_reporting");
		$old_display_errors = ini_get ("display_errors");
		ini_set ("error_reporting", E_ALL);
		ini_set ("display_errors", "1");
		ob_start ();
		eregi ($expr, "");
		$msg = ob_get_contents ();
		ob_end_clean ();
		ini_set ("error_reporting", $old_error_reporting);
		ini_set ("display_errors", $old_display_errors);
		return ($msg == "");
	}
}
?>
