<?php
class lib_sorted_list
{
	/*
		$list elements:
			$table
			$filter
			$field_id
			$field_sort
	*/
	static public function create ($list, $data)
	{
		$data [$list ["field_sort"]] = self::_int_append (
			self::_int_prepare_names ($list)
		);
		lib_db::create ($list ["table"], $data);
	}

	static private function _int_append ($prepared)
	{
		$rows = lib_db::query_raw (
			"SELECT coalesce (" .
				"(" .
					"SELECT " . $prepared ["field_sort"] . " + 1 " .
					"FROM " . $prepared ["table"] . " " .
					(
						($prepared ["filter"] != "") ?
						"WHERE " . $prepared ["filter"] . " " :
						""
					) .
					"ORDER BY " . $prepared ["field_sort"] . " DESC " .
					"LIMIT 1" .
				"), " .
				"0" .
			") as result"
		);
		return ($rows [0]["result"]);
	}

	static public function move_forward ($list, $item_id)
	{
		$prepared = self::_int_prepare_names ($list);
		$escaped_id = lib_db::escape ($item_id);
		$filter =
			($prepared ["filter"] != "") ?
			"(" . $prepared ["filter"] . ") AND " :
			"";
		$rows = lib_db::query_raw (
			"SELECT " . $prepared ["field_id"] . " AS id_field " .
			"FROM " . $prepared ["table"] . " " .
			"WHERE " .
				$filter .
				$prepared ["field_sort"] . " < (" .
					"SELECT " . $prepared ["field_sort"] . " " .
					"FROM " . $prepared ["table"] . " " .
					"WHERE " .
						$filter .
						$prepared ["field_id"] . "='" . $escaped_id . "'" .
				") " .
			"ORDER BY " . $prepared ["field_sort"] . " DESC " .
			"LIMIT 1"
		);
		if (count ($rows) == 0) {
			return (false);
		}
		self::_int_swap ($prepared, $escaped_id, $rows [0]["id_field"]);
		return (true);
	}

	static public function move_backward ($list, $item_id)
	{
		$prepared = self::_int_prepare_names ($list);
		$escaped_id = lib_db::escape ($item_id);
		$filter =
			($prepared ["filter"] != "") ?
			"(" . $prepared ["filter"] . ") AND " :
			"";
		$rows = lib_db::query_raw (
			"SELECT " . $prepared ["field_id"] . " AS id_field " .
			"FROM " . $prepared ["table"] . " " .
			"WHERE " .
				$filter .
				$prepared ["field_sort"] . " > (" .
					"SELECT " . $prepared ["field_sort"] . " " .
					"FROM " . $prepared ["table"] . " " .
					"WHERE " .
						$filter .
						$prepared ["field_id"] . "='" . $escaped_id . "'" .
				") " .
			"ORDER BY " . $prepared ["field_sort"] . " ASC " .
			"LIMIT 1"
		);
		if (count ($rows) == 0) {
			return (false);
		}
		self::_int_swap ($prepared, $escaped_id, $rows [0]["id_field"]);
		return (true);
	}

	static private function _int_swap ($prepared, $first_id, $second_id)
	{
		$filter =
			($prepared ["filter"] != "") ?
			"(" . $prepared ["filter"] . ") AND " :
			"";
		lib_db::query_raw (
			"UPDATE " . $prepared ["table"] . " " .
			"SET " .
				$prepared ["field_sort"] .
				"=" .
				"CASE " . $prepared ["field_id"] . " " .
					"WHEN " . $first_id . " " .
					"THEN " .
						"(" .
							"SELECT " . $prepared ["field_sort"] . " " .
							"FROM " . $prepared ["table"] . " " .
							"WHERE " .
								$filter .
								$prepared ["field_id"] . "='" . $second_id . "'" .
						") " .
					"WHEN " . $second_id . " " .
					"THEN " .
						"(" .
							"SELECT " . $prepared ["field_sort"] . " " .
							"FROM " . $prepared ["table"] . " " .
							"WHERE " .
								$filter .
								$prepared ["field_id"] . "='" . $first_id . "'" .
						") " .
				"END " .
			"WHERE " .
				$filter .
				"(" .
					$prepared ["field_id"] . "='" . $first_id . "' OR " .
					$prepared ["field_id"] . "='" . $second_id . "'" .
				")"
		);
	}

	static private function _int_prepare_names ($list)
	{
		return (array (
			"table" => lib_db::escape ($list ["table"]),
			"filter" => lib_db::build_filter ($list ["table"], $list ["filter"]),
			"field_id" => lib_db::escape ($list ["field_id"]),
			"field_sort" => lib_db::escape ($list ["field_sort"])
		));
	}
}
?>
