/*
Requires:
	functions_event.js
*/

function context_view (styles, callback)
{
	this.styles = styles;
	this.callback = callback;
	this.dom_main = this._int_create_main ();
	this.block_obj = new mouse_block ();
	this.visible = false;
}

context_view.prototype = {
	show: function (items, pos_left, pos_top) {
		var dom_main;

		if (this.visible) {
			return;
		}
		this._int_set_items (items);
		dom_main = this.dom_main;
		dom_main.style.left = pos_left + 'px';
		dom_main.style.top = pos_top + 'px';
		document.body.appendChild (dom_main);
		this.block_obj.start (dom_main);
		this.visible = true;
	},

	hide: function () {
		if (this.visible == false) {
			return;
		}
		this.block_obj.stop ();
		document.body.removeChild (this.dom_main);
		this.visible = false;
	},

	_int_set_items: function (items) {
		dom_main = this.dom_main;
		while (dom_main.childNodes.length > 0) {
			dom_main.removeChild (dom_main.childNodes [0]);
		}
		for (i in items) {
			dom_main.appendChild (
				(items [i] !== null) ?
				this._int_create_item (items [i]) :
				this._int_create_separator ()
			);
		}
	},

	_int_create_main: function () {
		var dom_main;

		dom_main = document.createElement ('div');
		dom_main.className = this.styles ['main'];
		dom_main.style.position = 'absolute';
		return (dom_main);
	},

	_int_create_item: function (info) {
		var this_obj, dom_item;

		this_obj = this;
		dom_item = document.createElement ('div');
		dom_item.innerHTML = info ['value'];
		dom_item.className = this.styles ['item_low'];
		event_handler_add (
			dom_item,
			'mouseover',
			function () {dom_item.className = this_obj.styles ['item_high'];}
		);
		event_handler_add (
			dom_item,
			'mouseout',
			function () {dom_item.className = this_obj.styles ['item_low'];}
		);
		event_handler_add (
			dom_item,
			'click',
			function () {this_obj.callback (info ['key']);}
		);
		return (dom_item);
	},

	_int_create_separator: function () {
		return (document.createElement ('hr'));
	}
};
