function item_fade ()
{
	this.dom_block = null;
	this.callback = null;
	this.rgb_now = null;
	this.rgb_end = null;
	this.delay = null;
	this.steps = null;
	this.timer_id = null;
}

item_fade.prototype = {
	attach: function (block_name, callback) {
		this.dom_block = document.getElementById (block_name);
		this.callback = callback;
	},

	run: function (rgb_start, rgb_end, milliseconds) {
		this.rgb_now = {red: rgb_start ['red'], green: rgb_start ['green'], blue: rgb_start ['blue']};
		this.rgb_end = {red: rgb_end ['red'], green: rgb_end ['green'], blue: rgb_end ['blue']};
		this.delay = 50;
		this.steps = Math.floor (milliseconds / this.delay) + ((milliseconds % this.delay) ? 1 : 0);
		this._int_update ();
		this._int_set_timer ();
	},

	_int_update: function () {
		this.dom_block.style.color =
			'rgb(' +
				this.rgb_now ['red'] + ', ' +
				this.rgb_now ['green'] + ', ' +
				this.rgb_now ['blue'] +
			')';
	},

	_int_step: function () {
		this.rgb_now ['red'] += Math.floor ((this.rgb_end ['red'] - this.rgb_now ['red']) / this.steps);
		this.rgb_now ['green'] += Math.floor ((this.rgb_end ['green'] - this.rgb_now ['green']) / this.steps);
		this.rgb_now ['blue'] += Math.floor ((this.rgb_end ['blue'] - this.rgb_now ['blue']) / this.steps);
		--this.steps;
	},

	_int_set_timer: function () {
		var this_obj;

		if (this.timer_id == null) {
			if (this.steps) {
				this_obj = this;
				this.timer_id = setInterval (function () {this_obj._int_interrupt ();}, this.delay);
			}
		} else {
			if (this.steps == 0) {
				clearInterval (this.timer_id);
				this.timer_id = null;
				if (this.callback) {
					this.callback ();
				}
			}
		}
	},

	_int_interrupt: function () {
		this._int_step ();
		this._int_update ();
		this._int_set_timer ();
	}
};
