/*
Requires:
	functions_event.js
*/

/*
   FIXME: Must use MSG_SYSTEM_ONUNLOAD to unregister the handler from the dispatcher, this will
   render message_dispatcher._int_is_valid() unnecessary.
*/

var MSG_SYSTEM_ONLOAD = 1;
var MSG_SYSTEM_ONUNLOAD = 2;

function message_handler (dispatcher)
{
	var this_obj;

	this.dispatcher = dispatcher;
	this.cookie = this.dispatcher.add_handler (this, window);
	this.messages = [];

	this_obj = this;
	event_handler_add (
		window,
		'load',
		function () {this_obj.broadcast (MSG_SYSTEM_ONLOAD, null);}
	);
	event_handler_add (
		window,
		'unload',
		function () {this_obj.broadcast (MSG_SYSTEM_ONUNLOAD, null);}
	);
}

message_handler.prototype = {
	add_message: function (code, func) {
		this.messages [code] = func;
	},

	send: function (code, dest_cookie, info) {
		return (this.dispatcher.process_message (code, this.cookie, dest_cookie, info));
	},

	broadcast: function (code, info) {
		return (this.dispatcher.process_message (code, this.cookie, null, info));
	},

	handle: function (code, source_cookie, info) {
		if (code in this.messages) {
			return (this.messages [code] (code, this.cookie, source_cookie, info));
		} else {
			return (null);
		}
	}
};
