/*
   Info parameter properties:

   main_style	CSS style for main window. Ignored if null.
   title_exists	Boolean indicating whether window has a title.
   title_style	CSS style for title area. Ignored if null.
   title_text	Text for title area. Ignored if null.
   client_style	CSS style for client area. Ignored if null.
*/

function window_view (info)
{
	this.dom_main = this._int_create_object (info);
	this.visible = false;
}

window_view.prototype = {
	show: function (pos_left, pos_top) {
		if (this.visible == false) {
			dom_main = this.dom_main;
			dom_main.style.left = pos_left + 'px';
			dom_main.style.top = pos_top + 'px';
			document.body.appendChild (dom_main);
			this.visible = true;
		}
	},

	hide: function () {
		if (this.visible) {
			document.body.removeChild (this.dom_main);
			this.visible = false;
		}
	},

	get_dom_client: function () {
		return (this.dom_main.childNodes [1]);
	},

	_int_create_object: function (info) {
		var dom_main, dom_title, dom_client;

		dom_main = this._int_create_main (info);
		if ((dom_title = this._int_create_title (info)) !== null) {
			dom_main.appendChild (dom_title);
		}
		dom_client = this._int_create_client (info);
		dom_main.appendChild (dom_client);
		return (dom_main);
	},

	_int_create_main: function (info) {
		var dom_main;

		dom_main = document.createElement ('div');
		if (info ['main_style'] !== null) {
			dom_main.className = info ['main_style'];
		}
		dom_main.style.position = 'absolute';
		return (dom_main);
	},

	_int_create_title: function (info) {
		var dom_title;

		if (info ['title_exists'] == false) {
			return (null);
		}
		dom_title = document.createElement ('div');
		if (info ['title_style'] !== null) {
			dom_title.className = info ['title_style'];
		}
		if (info ['title_text'] !== null) {
			dom_title.innerText = info ['title_text'];
		}
		dom_title.style.width = '100%';
		return (dom_title);
	},

	_int_create_client: function (info) {
		var dom_client;

		dom_client = document.createElement ('div');
		if (info ['client_style'] !== null) {
			dom_client.className = info ['client_style'];
		}
		dom_client.style.width = '100%';
		dom_client.style.height = '100%';
		return (dom_client);
	}
};
