/*
	NB: Under IE the event handler is not called as a method of the DOM object to which it is attached. This means
	that the "this" variable cannot be used to access the DOM object. This discrepancy is caused by the attachEvent()
	method which is used to attach the event under IE.
*/
function event_handler_add (object, name, handler)
{
	var real_handler, cookie;

	real_handler =
		('event' in window) ?
		function () {return (handler (window.event));} :
		handler;
	cookie = {
		object: object,
		name: name,
		real_handler: real_handler
	};
	if ('addEventListener' in object) {
		object.addEventListener (name, real_handler, false);
		return (cookie);
	} else if ('attachEvent' in object) {
		object.attachEvent ('on' + name, real_handler);
		return (cookie);
	} else {
		return (null);
	}
}

function event_handler_remove (cookie)
{
	if ('removeEventListener' in cookie ['object']) {
		cookie ['object'].removeEventListener (
			cookie ['name'],
			cookie ['real_handler'],
			false
		);
		return (true);
	} else if ('detachEvent' in cookie ['object']) {
		cookie ['object'].detachEvent (
			'on' + cookie ['name'],
			cookie ['real_handler']
		);
		return (true);
	} else {
		return (false);
	}
}

function event_stop_propagation (event)
{
	if ('stopPropagation' in event) {
		event.stopPropagation ();
		return (true);
	} else if ('cancelBubble' in event) {
		event.cancelBubble = true;
		return (true);
	} else {
		return (false);
	}
}

function event_prevent_default (event)
{
	if ('preventDefault' in event) {
		event.preventDefault ();
		return (true);
	} else if ('returnValue' in event) {
		event.returnValue = false;
		return (true);
	} else {
		return (false);
	}
}
